/***************************************************************************
                         add.cpp  -  description
                             -------------------
    begin                : czw lut 20 18:50:23 CET 2003
    copyright            : (C) 2003 by Pawel Pustelnik
    email                : pawelpus@o2.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "add.h"
#include "home.h"

#include <qvariant.h>
#include <qframe.h>
#include <qheader.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qtoolbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qmessagebox.h>
#include <qcombobox.h>
#include <qtextstream.h>
#include <qfile.h>

#include <stdio.h>
#include <stdlib.h>



/* 
 *  Constructs a Add as a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
Add::Add( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl)

{
   QString   name_home;

   QFont font("Helvetica",11);
    setFont(font);

   if ( !name )
	    setName( "Add" );
   
   	setMouseTracking(FALSE);	
   
 
    menu = new QPopupMenu( this );
    menu->insertItem(tr("Remove all stations"),this,SLOT(Remove_all()));
    menu->insertItem(tr("Save and Close"),this,SLOT(Save_list()));
    menu->insertItem(tr("Remove selected"),this,SLOT(Remove_from_list()),Key_Delete);
    menu->setFont(font);	
    menu->setStyle(tr("Default"));

    textLabel1_2 = new QLabel( this, "textLabel1_2" );
    textLabel1_2->setGeometry( QRect( 10, 370, 107, 20 ) );

    line1 = new QFrame( this, "line1" );
    line1->setGeometry( QRect( 0, 320, 351, 16 ) );
    line1->setFrameShape( QFrame::HLine );
    line1->setFrameShadow( QFrame::Sunken );
    line1->setFrameShape( QFrame::HLine );

    line1_2 = new QFrame( this, "line1_2" );
    line1_2->setGeometry( QRect( 0, 390, 351, 16 ) );
    line1_2->setFrameShape( QFrame::HLine );
    line1_2->setFrameShadow( QFrame::Sunken );
    line1_2->setFrameShape( QFrame::HLine );

    textLabel1 = new QLabel( this, "textLabel1" );
    textLabel1->setGeometry( QRect( 10, 340, 90, 20 ) );

    Name_edit = new QLineEdit( this, "Name_edit" );
    Name_edit->setGeometry( QRect( 110, 340, 220, 22 ) );

    Freq_edit = new QLineEdit( this, "Freq_edit" );
    Freq_edit->setGeometry( QRect( 130, 370, 80, 22 ) );
    

    Rem_button = new QToolButton( this, "Rem_button" );
    Rem_button->setGeometry( QRect( 140, 300, 80, 20 ) );
    Rem_button->setPaletteBackgroundColor(QColor(226,226,226));

    Add_button = new QToolButton( this, "Add_button" );
    Add_button->setGeometry( QRect( 220, 370, 50, 20 ) );
    Add_button->setPaletteBackgroundColor(QColor(226,226,226));

    Edit_button = new QToolButton( this, "Edit_button" );
    Edit_button->setGeometry( QRect( 275, 370, 50, 20 ) );
    Edit_button->setPaletteBackgroundColor(QColor(226,226,226));

    Save_button = new QToolButton( this, "Save_button" );
    Save_button->setPaletteBackgroundColor(QColor(226,226,226));
    Save_button->setGeometry( QRect( 70, 410, 80, 20 ) );

    Quit_button = new QToolButton( this, "Quit_button" );
    Quit_button->setGeometry( QRect( 200, 410, 80, 20 ) );
    Quit_button->setPaletteBackgroundColor(QColor(226,226,226));
   

    Station_list = new QListView( this, "Station_list" );
    Station_list->addColumn( tr( "Station's Name" ) );
    Station_list->header()->setClickEnabled( FALSE, Station_list->header()->count() - 1 );
    Station_list->addColumn( tr( "Frequency [MHz]" ) );
    Station_list->header()->setClickEnabled( FALSE, Station_list->header()->count() - 1 );
    Station_list->setGeometry( QRect( 30, 40, 290, 250 ) );
    Station_list->setShowSortIndicator( TRUE );
    Station_list->setItemMargin( 0 );
    Station_list->setResizeMode( QListView::AllColumns );
    Station_list->setAllColumnsShowFocus( TRUE );
    Station_list->setShowSortIndicator( FALSE );

    Label_how_many = new QLabel( this, "Label_how_many" );
    Label_how_many->setGeometry( QRect( 40, 10, 40, 20 ) );

    textLabel1_3 = new QLabel( this, "textLabel1_3" );
    textLabel1_3->setGeometry( QRect( 80, 10, 161, 20 ) );

    QToolTip::add(Rem_button , tr( "Remove selected station" ) );
    QWhatsThis::add( Rem_button, tr( "Remove selected station" ) );

    QToolTip::add( Add_button, tr( "Add new station" ) );
    QWhatsThis::add(Add_button , tr( "Add new station" ) );

    QToolTip::add(Edit_button , tr( "Edit selected station" ) );
    QWhatsThis::add(Edit_button , tr( "Edit selected station" ) );

    QToolTip::add( Save_button, tr( "Save list and close window" ) );
    QWhatsThis::add( Save_button, tr( "Save list and close window" ) );

    QToolTip::add(Quit_button , tr( "Close window without saving" ) );
    QWhatsThis::add( Quit_button, tr( "Close window without saving" ) );

    languageChange();
    
    resize( QSize(350, 438).expandedTo(minimumSizeHint()) );


    connect( Add_button, SIGNAL( clicked() ), this, SLOT( Add_to_list() ) );
    connect( Rem_button, SIGNAL( clicked() ), this, SLOT( Remove_from_list() ) );
    connect( Save_button, SIGNAL( clicked() ), this, SLOT( Save_list() ) );
    connect( Quit_button, SIGNAL( clicked() ), this, SLOT( Cancel() ) );
    connect( Edit_button, SIGNAL( clicked() ), this, SLOT( Edit_to_list() ) );
    connect( Station_list, SIGNAL( clicked(QListViewItem*) ), this, SLOT( List_edit() ) );

}



/*
 *  Destroys the object and frees any allocated resources
 */
Add::~Add()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void Add::languageChange()
{

    setCaption( tr( "Editing stations" ) );
    textLabel1_2->setText( tr( "Frequency [Mhz] :" ) );

    textLabel1->setText( tr( "Station's Name :" ) );

    Rem_button->setText( tr( "Remove" ) );

    Add_button->setText( tr( "Add" ) );

    Edit_button->setText( tr( "Change" ) );
 
    Save_button->setText( tr( "Save" ) );
    
    Quit_button->setText( tr( "Cancel" ) );
 
    Station_list->header()->setLabel( 0, tr( "Station's Name" ) );
    Station_list->header()->setLabel( 1, tr( "Frequency [MHz]" ) );
    Label_how_many->setText( tr( "0" ) );

    textLabel1_3->setText( tr( "station(s) in the user's list:" ) );
    

    textLabel1_2->setBackgroundOrigin(ParentOrigin);
    Label_how_many->setBackgroundOrigin(ParentOrigin);
    textLabel1_3->setBackgroundOrigin(ParentOrigin);
    textLabel1->setBackgroundOrigin(ParentOrigin);
    line1->setBackgroundOrigin(ParentOrigin);
    line1_2->setBackgroundOrigin(ParentOrigin);
    
 
    
}


void Add::Remove_from_list()
{
     if   ( (Station_list->selectedItem() != 0 ) &&(Station_list->currentItem()->text(0) != "") &&  (Station_list->currentItem()->text(1) != "") && (Label_how_many->text() != "0")  )
      {
        Station_list->takeItem(Station_list->currentItem());
        Label_how_many->setText( QString::number( Label_how_many->text().toInt() - 1 ) );
      }
}

void Add::Save_list()
{

  int i,max;
  QString nps;
  char dane[100];
  QListViewItem *item;
  FILE *wyj, *wyj2;
  QString name_home;
  QString name[260];
  QString freqn[260];
  char path[100];

  name_home = home_dir();
  name_home.append("/.qtradio/programs");
  strcpy(&path[0], name_home);
  wyj = fopen(&path[0],"w+");

  name_home = home_dir();
  name_home.append("/.qtradio/programs_freq");
  strcpy(&path[0], name_home);
  wyj2 = fopen(&path[0],"w+");


    i = Label_how_many->text().toInt();
     max = i;
     item = Station_list->lastItem();
     //QMessageBox::information( this, "KDERadio",item->text(0));
    while ( i != 0 )
    {
      //printf("%i\n",i);
      //item = item->itemAbove();
      Station_list->setSelected(item,1);
      nps = Station_list->selectedItem()->text(0);
      //strcpy(&dane[0],nps);
      //printf("%s\n",&dane[0]);  
      //fprintf(wyj,"%s\n",&dane[0]);
      name[i] = nps;
      nps  = Station_list->selectedItem()->text(1);
      //strcpy(&dane[0],nps);
      //printf("%s\n",&dane[0]);
      //fprintf(wyj2,"%s\n",&dane[0]);  
      freqn[i] = nps;
      item = item->itemAbove();
      i--;
      }

      i = 1;
      while ( i <= max )
      {
         strcpy(&dane[0],name[i]);
         fprintf(wyj,"%s\n",&dane[0]);
         strcpy(&dane[0],freqn[i]);
         fprintf(wyj2,"%s\n",&dane[0]);
         i++;
      }
         
  fclose(wyj);
  fclose(wyj2);

  Add::close();
 
}

void Add::Add_to_list()
{
  QListViewItem *item;

  if ( (Name_edit->text() != "") && (Freq_edit->text() != "") && (Label_how_many->text() == "0") )
  {
    item = new QListViewItem(Station_list);
    item->setText(0,Name_edit->text());
    item->setText(1,Freq_edit->text());
    Name_edit->setText("");
    Freq_edit->setText("");
    Label_how_many->setText( QString::number( Label_how_many->text().toInt() + 1 ) );
  }

  if ( (Name_edit->text() != "") && (Freq_edit->text() != "") && (Label_how_many->text() != "0") )
  {
    item = new QListViewItem(Station_list,Station_list->lastItem());
    item->setText(0,Name_edit->text());
    item->setText(1,Freq_edit->text());
    Name_edit->setText("");
    Freq_edit->setText("");
    Label_how_many->setText( QString::number( Label_how_many->text().toInt() + 1 ) );
  }
}

void Add::Edit_to_list()
{
   if   ( (Station_list->selectedItem() != 0 )  && (Label_how_many->text() != "0")  )
   {
      Station_list->selectedItem()->setText(0,Name_edit->text());
      Station_list->selectedItem()->setText(1,Freq_edit->text());   
  }
}

void Add::List_edit()
{
  if    (Station_list->selectedItem() != 0 )
  {
    Name_edit->setText( Station_list->selectedItem()->text(0) );
    Freq_edit->setText( Station_list->selectedItem()->text(1) );
  }
}

void Add::Cancel()
{
  Add::close();  
}

void Add::Remove_all()
{
	Station_list->clear();
	Label_how_many->setText("0");
}
  
