/***************************************************************************
                         info.cpp  -  description
                             -------------------
    begin                : czw lut 20 18:50:23 CET 2003
    copyright            : (C) 2003 by Pawel Pustelnik
    email                : pawelpus@o2.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "home.h"
#include "info.h"
#include "shortcut.h"
#include <stdio.h>

#include <qvariant.h>
#include <qcombobox.h>
#include <qgroupbox.h>
#include <qheader.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qtabwidget.h>
#include <qtoolbutton.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qfont.h>
#include <qmessagebox.h>

/*
 *  Constructs a Settings as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
Settings::Settings( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )

{
    QFont font("Helvetica",11);
    setFont(font);

    if ( !name )
	setName( "Settings" );
    

    toolButton4 = new QToolButton( this, "toolButton4" );
    toolButton4->setGeometry( QRect( 120, 420, 80, 24 ) );
    toolButton4->setPaletteBackgroundColor(QColor(226,226,226));

    toolButton5 = new QToolButton( this, "toolButton5" );
    toolButton5->setGeometry( QRect( 230, 420, 90, 24 ) );
    toolButton5->setPaletteBackgroundColor(QColor(226,226,226));
    

    tabWidget2 = new QTabWidget( this, "tabWidget2" );
    tabWidget2->setGeometry( QRect( 10, 10, 430, 400 ) );
   

    tab = new QWidget( tabWidget2, "tab" );

    groupBox1 = new QGroupBox( tab, "groupBox1" );
    groupBox1->setGeometry( QRect( 10, 10, 410, 110 ) );
    groupBox1->setAlignment( int( QGroupBox::AlignHCenter ) );
    groupBox1->setFlat( FALSE );

    textLabel1 = new QLabel( groupBox1, "textLabel1" );
    textLabel1->setGeometry( QRect( 10, 20, 100, 20 ) );

    textLabel3 = new QLabel( groupBox1, "textLabel3" );
    textLabel3->setGeometry( QRect( 10, 40, 100, 20 ) );

    textLabel5 = new QLabel( groupBox1, "textLabel5" );
    textLabel5->setGeometry( QRect( 10, 60, 100, 20 ) );

    textLabel6 = new QLabel( groupBox1, "textLabel6" );
    textLabel6->setGeometry( QRect( 130, 60, 61, 20 ) );

    textLabel4 = new QLabel( groupBox1, "textLabel4" );
    textLabel4->setGeometry( QRect( 130, 40, 61, 20 ) );

    textLabel2 = new QLabel( groupBox1, "textLabel2" );
    textLabel2->setGeometry( QRect( 130, 20, 100, 20 ) );

    textLabel7 = new QLabel( groupBox1, "textLabel7" );
    textLabel7->setGeometry( QRect( 10, 80, 100, 20 ) );

    textLabel8 = new QLabel( groupBox1, "textLabel8" );
    textLabel8->setGeometry( QRect( 130, 80, 61, 20 ) );

    groupBox2 = new QGroupBox( tab, "groupBox2" );
    groupBox2->setGeometry( QRect( 10, 130, 410, 110 ) );
    groupBox2->setAlignment( int( QGroupBox::AlignHCenter ) );

    textLabel10 = new QLabel( groupBox2, "textLabel10" );
    textLabel10->setGeometry( QRect( 10, 50, 120, 20 ) );

    textLabel11 = new QLabel( groupBox2, "textLabel11" );
    textLabel11->setGeometry( QRect( 10, 80, 120, 20 ) );

    spinBox1 = new QSpinBox( groupBox2, "spinBox1" );
    spinBox1->setGeometry( QRect( 140, 50, 55, 20 ) );
    spinBox1->setMaxValue( 108 );
    spinBox1->setMinValue( 65 );
    spinBox1->setValue( 87 );

    spinBox2 = new QSpinBox( groupBox2, "spinBox2" );
    spinBox2->setGeometry( QRect( 140, 80, 55, 20 ) );
    spinBox2->setMaxValue( 108 );
    spinBox2->setMinValue( 65 );
    spinBox2->setValue( 108 );

    textLabel13 = new QLabel( groupBox2, "textLabel13" );
    textLabel13->setGeometry( QRect( 200, 80, 68, 20 ) );

    textLabel9 = new QLabel( groupBox2, "textLabel9" );
    textLabel9->setGeometry( QRect( 10, 20, 100, 20 ) );

    textLabel12 = new QLabel( groupBox2, "textLabel12" );
    textLabel12->setGeometry( QRect( 200, 54, 68, 20 ) );

    lineEdit3 = new QLineEdit( groupBox2, "lineEdit3" );
    lineEdit3->setGeometry( QRect( 130, 20, 100, 20 ) );

    groupBox3 = new QGroupBox( tab, "groupBox3" );
    groupBox3->setGeometry( QRect( 10, 250, 410, 110 ) );
    groupBox3->setAlignment( int( QGroupBox::AlignHCenter ) );

    textLabel14 = new QLabel( groupBox3, "textLabel14" );
    textLabel14->setGeometry( QRect( 10, 20, 100, 20 ) );

    textLabel15 = new QLabel( groupBox3, "textLabel15" );
    textLabel15->setGeometry( QRect( 10, 50, 100, 20 ) );

    comboBox7 = new QComboBox( FALSE, groupBox3, "comboBox7" );
    comboBox7->setGeometry( QRect( 120, 50, 130, 20 ) );

    lineEdit4 = new QLineEdit( groupBox3, "lineEdit4" );
    lineEdit4->setGeometry( QRect( 120, 20, 130, 20 ) );
    tabWidget2->insertTab( tab, "" );

    tab_2 = new QWidget( tabWidget2, "tab_2" );

    groupBox5 = new QGroupBox( tab_2, "groupBox5" );
    groupBox5->setGeometry( QRect( 10, 10, 410, 100 ) );
    groupBox5->setAlignment( int( QGroupBox::AlignHCenter ) );

    textLabel16 = new QLabel( groupBox5, "textLabel16" );
    textLabel16->setGeometry( QRect( 10, 30, 110, 20 ) );

    textLabel17 = new QLabel( groupBox5, "textLabel17" );
    textLabel17->setGeometry( QRect( 10, 60, 110, 20 ) );

    comboBox9 = new QComboBox( FALSE, groupBox5, "comboBox9" );
    comboBox9->setGeometry( QRect( 190, 60, 98, 20 ) );

    comboBox8 = new QComboBox( FALSE, groupBox5, "comboBox8" );
    comboBox8->setGeometry( QRect( 190, 30, 98, 20 ) );

    groupBox7 = new QGroupBox( tab_2, "groupBox7" );
    groupBox7->setGeometry( QRect( 10, 230, 410, 130 ) );
    groupBox7->setAlignment( int( QGroupBox::AlignHCenter ) );

    listView1 = new QListView( groupBox7, "listView1" );
    listView1->addColumn( tr( "Skin's name" ) );
    listView1->header()->setClickEnabled( FALSE, listView1->header()->count() - 1 );
    listView1->addColumn( tr( "Path" ) );
    listView1->header()->setClickEnabled( FALSE, listView1->header()->count() - 1 );
    listView1->setGeometry( QRect( 10, 20, 390, 100 ) );
    listView1->setShowSortIndicator( TRUE );
    listView1->setItemMargin( 0 );
    listView1->setResizeMode( QListView::AllColumns );
    listView1->setAllColumnsShowFocus( TRUE );
    listView1->setShowSortIndicator( FALSE );
   

    groupBox6 = new QGroupBox( tab_2, "groupBox6" );
    groupBox6->setGeometry( QRect( 10, 120, 410, 100 ) );
    groupBox6->setAlignment( int( QGroupBox::AlignHCenter ) );

    textLabel19 = new QLabel( groupBox6, "textLabel19" );
    textLabel19->setGeometry( QRect( 10, 60, 129, 20 ) );

    textLabel18 = new QLabel( groupBox6, "textLabel18" );
    textLabel18->setGeometry( QRect( 10, 30, 68, 20 ) );

    comboBox10 = new QComboBox( FALSE, groupBox6, "comboBox10" );
    comboBox10->setGeometry( QRect( 150, 60, 100, 20 ) );

    lineEdit6 = new QLineEdit( groupBox6, "lineEdit6" );
    lineEdit6->setGeometry( QRect( 150, 30, 60, 20 ) );

    textLabel21 = new QLabel( groupBox6, "textLabel21" );
    textLabel21->setGeometry( QRect( 220, 30, 30, 20 ) );
    tabWidget2->insertTab( tab_2, "" );

    tab_3 = new QWidget( tabWidget2, "tab_3" );

    listView2 = new QListView( tab_3, "listView2" );
    listView2->addColumn( tr( "Signal" ) );
    listView2->header()->setClickEnabled( FALSE, listView2->header()->count() - 1 );
    listView2->addColumn( tr( "Key" ) );
    listView2->header()->setClickEnabled( FALSE, listView2->header()->count() - 1 );
    listView2->setGeometry( QRect( 10, 20, 410, 300 ) );
    listView2->setShowSortIndicator( TRUE );
    listView2->setItemMargin( 0 );
    listView2->setResizeMode( QListView::AllColumns );
    listView2->setAllColumnsShowFocus( TRUE );
    listView2->setShowSortIndicator( FALSE );
    
    textLabel20 = new QPushButton( tab_3, "textLabel20" );
    textLabel20->setGeometry( QRect( 150, 340, 120, 25 ) );
    tabWidget2->insertTab( tab_3, "" );
    languageChange();
    resize( QSize(455, 449).expandedTo(minimumSizeHint()) );
                                                                                                             
    connect( textLabel20, SIGNAL( clicked() ), this, SLOT( New_shortcut() ) );
    connect( toolButton4, SIGNAL( clicked() ), this, SLOT( Save() ) );
    connect( toolButton5, SIGNAL( clicked() ), this, SLOT( Quit() ) );
    connect( listView2, SIGNAL( clicked(QListViewItem*) ), this, SLOT( When_clicked() ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
Settings::~Settings()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void Settings::languageChange()
{
    setCaption( tr( "Settings for QtRadio" ) );
    toolButton4->setText( tr( "Save" ) );
    toolButton5->setText( tr( "Exit" ) );
    groupBox1->setTitle( tr( "Video Driver" ) );
    textLabel1->setText( tr( "Driver:" ) );
    textLabel3->setText( tr( "Stereo:" ) );
    textLabel5->setText( tr( "Mutable:" ) );
    textLabel6->setText( tr( "yes/no" ) );
    textLabel4->setText( tr( "yes/no" ) );
    textLabel2->setText( tr( "driver's name" ) );
    textLabel7->setText( tr( "RDS:" ) );
    textLabel8->setText( tr( "yes/no" ) );
    groupBox2->setTitle( tr( "Radio" ) );
    textLabel10->setText( tr( "Min. Frequency:" ) );
    textLabel11->setText( tr( "Max. Frequency:" ) );
    textLabel13->setText( tr( "MHz" ) );
    textLabel9->setText( tr( "Device:" ) );
    textLabel12->setText( tr( "MHz" ) );
    lineEdit3->setText( tr( "device's name" ) );
    groupBox3->setTitle( tr( "Mixer" ) );
    textLabel14->setText( tr( "Device:" ) );
    textLabel15->setText( tr( "Main mixer:" ) );
    lineEdit4->setText( tr( "device's name" ) );
    tabWidget2->changeTab( tab, tr( "Devices" ) );
    groupBox5->setTitle( tr( "Main Window" ) );
    textLabel16->setText( tr( "Dock on start:" ) );
    textLabel17->setText( tr( "Expanded version" ) );
    groupBox7->setTitle( tr( "Skin" ) );
    listView1->header()->setLabel( 0, tr( "Skin's name" ) );
    listView1->header()->setLabel( 1, tr( "Path" ) );
    groupBox6->setTitle( tr( "Seeking" ) );
    textLabel19->setText( tr( "Min. Signal's Strength:" ) );
    textLabel18->setText( tr( "Precision:" ) );
    comboBox10->clear();
    comboBox10->insertItem( tr( "1" ) );
    comboBox10->insertItem( tr( "2" ) );
    comboBox10->insertItem( tr( "3" ) );
    comboBox10->insertItem( tr( "4" ) );
    comboBox10->insertItem( tr( "5" ) );
    comboBox10->insertItem( tr( "6" ) );
    comboBox10->insertItem( tr( "7" ) );
    comboBox10->insertItem( tr( "8" ) );
    lineEdit6->setText( tr( "0.10" ) );
    textLabel21->setText( tr( "MHz" ) );
    tabWidget2->changeTab( tab_2, tr( "Options" ) );
    listView2->header()->setLabel( 0, tr( "Signal" ) );
    listView2->header()->setLabel( 1, tr( "Key" ) );
    textLabel20->setText( tr( "New Shortcut:" ) );
    tabWidget2->changeTab( tab_3, tr( "Keys" ) );

    QToolTip::add( toolButton4, tr( "Save settings and close this window" ) );
    QWhatsThis::add( toolButton4, tr( "Save settings and close this window" ) );

    QToolTip::add( toolButton5, tr( "Close this window without saving" ) );
    QWhatsThis::add( toolButton5, tr( "Close this window without saving" ) );

    QToolTip::add( textLabel20, tr( "Define new shortcut " ) );
    QWhatsThis::add( textLabel20, tr( "Define new shortcut " ) );

}

void Settings::keyPressEvent( QKeyEvent *k )
{

    

}

void Settings::Save()
{
  QString name_home,tmp;
  char temp[150];
  char path[150];
  
  //saving data from tuner and mixer section
  FILE *wyj;
  name_home = home_dir();
  name_home.append("/.qtradio/settings");
  strcpy(&path[0], name_home);
  //printf("%s\n",&path[0]);
  wyj = fopen(&path[0],"w");
  strcpy(&temp[0], lineEdit3->text() );
  fprintf(wyj,"%s\n",&temp[0]);
  
  fprintf(wyj,"%i\n",spinBox1->value());
  
  fprintf(wyj,"%i\n",spinBox2->value());

  strcpy(&temp[0], lineEdit4->text() );
  fprintf(wyj,"%s\n",&temp[0]);
  
  strcpy(&temp[0], comboBox7->currentText() );
  fprintf(wyj,"%s\n",&temp[0]);
  
  strcpy(&temp[0], comboBox9->currentText() );
  fprintf(wyj,"%s\n",&temp[0]);
  
  if ( comboBox8->currentText() == (tr("Yes")) ) tmp="DOCK=YES";
  else tmp="DOCK=NO";
  strcpy(&temp[0], tmp );
  fprintf(wyj,"%s\n",&temp[0]);
  
  tmp = lineEdit6->text();
  strcpy(&temp[0], tmp );
  fprintf(wyj,"%s\n",&temp[0]);
  
  tmp = comboBox10->currentText();
  strcpy(&temp[0], tmp );
  fprintf(wyj,"%s\n",&temp[0]);
  
  fclose(wyj);
  
  //SAVE SKIN'S DIR
  /*name_home = home_dir();
  name_home.append("/.qtradio/Skins/default");
  strcpy(&path[0], name_home);            
  wyj = fopen(&path[0],"w");
  strcpy(&temp[0], Skin_edit->text() );
  fprintf(wyj,"%s\n",&temp[0]);
  fclose(wyj);      */

  //save key sequences

  name_home = home_dir();
  name_home.append("/.qtradio/keys");
  strcpy(&path[0], name_home);
  //printf("%s\n",&path[0]);

  QListViewItem *item;
  QString nps[20];
  QString npss[20];
  int i = 15;
  item = listView2->lastItem();
  while ( i != 0 )
    {
        listView2->setSelected(item,1);
        nps[i] = listView2->selectedItem()->text(1);

         if ( listView2->selectedItem()->text(0) == tr("About") )
          npss[0] = nps[i];
          if ( listView2->selectedItem()->text(0)  == tr("About Qt") )
          npss[1] = nps[i];
          if ( listView2->selectedItem()->text(0)  == tr("Choose Skin") )
          npss[2] = nps[i];
          if ( listView2->selectedItem()->text(0)  == tr("Exit") )
          npss[3] = nps[i];
          if ( listView2->selectedItem()->text(0)  == tr("Frequency + 0.01 MHz") )
          npss[4] = nps[i];
          if ( listView2->selectedItem()->text(0)  == tr("Frequency + 0.1 MHz") )
          npss[5] = nps[i];
          if ( listView2->selectedItem()->text(0)  == tr("Frequency - 0.01 MHz") )
          npss[6] = nps[i];
          if ( listView2->selectedItem()->text(0)  == tr("Frequency - 0.1 MHz") )
          npss[7] = nps[i];
          if ( listView2->selectedItem()->text(0)  == tr("Next Station") )
          npss[8] = nps[i];
          if ( listView2->selectedItem()->text(0)  == tr("Power") )
          npss[9] = nps[i];
          if ( listView2->selectedItem()->text(0)  == tr("Previous Station") )
          npss[10] = nps[i];
          if ( listView2->selectedItem()->text(0)  == tr("Settings") )
          npss[11] = nps[i];
          if ( listView2->selectedItem()->text(0)  == tr("Show Station's list") )
          npss[12] = nps[i];
          if ( listView2->selectedItem()->text(0)  == tr("Volume Down") )
          npss[13] = nps[i];
          if ( listView2->selectedItem()->text(0)  == tr("Volume Up") )
          npss[14] = nps[i];
        
        item = item->itemAbove();
        i--;
      }

     
         
      i = 0;       
      wyj = fopen(&path[0],"w");
      while ( i <= 14 )
      {
          strcpy(&temp[0], npss[i] );
          fprintf(wyj,"%s\n",&temp[0]);
          i++;
        }         
                             
       fclose(wyj);            
        
  //QMessageBox::information( this, "QtRadio",(tr("You must click twice 'Power On/Off' to get all changes")));   
                                                                                       
 Settings::close(); 

}

void Settings::Quit()
{
     Settings::close(); 
  } 

void  Settings::Accept_new_key()
{


}
  
void  Settings::When_clicked()
{

}
  

void  Settings::New_shortcut()
{

  Shortcut *s = new Shortcut();
  QLabel *l = s->textLabel1;
  l->setText(listView2->selectedItem()->text(1) );
  s->exec();
   if    (listView2->selectedItem() != 0 )
   {
      listView2->selectedItem()->setText(1, s->textLabel1->text() );
  }

}

