/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Sat Apr 12 00:32:39 CEST 2003
    copyright            : (C) 2003 by Pawel Pustelnik
    email                : pawelpus@o2.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// Qt includes
#include <qapplication.h>
#include <qfont.h>
#include <qstring.h>
#include <qtextcodec.h>
#include <qtranslator.h>
#include <qcombobox.h>
#include <qtextstream.h>
#include <qfile.h>
#include <qdir.h>
#include <qmessagebox.h>
#include <qfileinfo.h>
#include <qlineedit.h>

//own includes
#include "qtradio.h"
#include "TrayIcon.h"
#include "radio_functions.h"
#include "home.h"

KDERadio *Radio;
TrayIcon *ti;


int main(int argc, char *argv[])
{
   int i;
   char data_file[150];
   QString name_home, first_line;
   QString tmp;
   QFile *file;
   QDir *dir;
   QTextStream *t;
   char device_name[50];
   bool dock=TRUE;	
	FILE *wyj;	
	
  QApplication a(argc, argv);
  a.setFont(QFont("helvetica", 12));
  QTranslator tor( 0 );
  // set the location where your .qm files are in load() below as the last parameter instead of "."
  // for development, use "/" to use the english original as
  // .qm files are stored in the base project directory.
  tor.load( QString("/usr/share/QtRadio/Languages/qtradio.") + QTextCodec::locale(), "." );
  a.installTranslator( &tor );
  /* uncomment the following line, if you want a Windows 95 look*/
  // a.setStyle(WindowsStyle);

 //file containing key sequences
     

  	Radio = new KDERadio();

  	a.setMainWidget(Radio);

    QComboBox *combo;
    QString temp,temp2,temp3,temp4,temp5,temp6;

    combo = Radio->Lista;



   // check if main dir '.kderadio' exists, if not = create it
   name_home = home_dir();
   name_home.append("/.qtradio");
   dir = new QDir(name_home);
   if ( ! dir->exists() )
    {
      strcpy(&data_file[0], name_home);
      mkdir(&data_file[0], S_IWUSR | S_IRUSR | S_IXUSR);
    }

   name_home = home_dir();
   name_home.append("/.qtradio/Skins");
   dir = new QDir(name_home);
   if ( ! dir->exists() )
    {
      strcpy(&data_file[0], name_home);
      mkdir(&data_file[0], S_IWUSR | S_IRUSR | S_IXUSR);
    }

    name_home = home_dir();
    name_home.append("/.qtradio/Skins/default");
    file = new QFile(name_home);
   if ( ! file->exists() )
   {
   	strcpy(&data_file[0], name_home);
      	creat(&data_file[0], S_IWUSR | S_IRUSR);
      	strcpy(&data_file[0], name_home);
      	wyj = fopen(&data_file[0],"w");
      	fprintf(wyj,"%s\n","/usr/share/QtRadio/Skins/Dark");
	fclose(wyj);
   }


    name_home = home_dir();
   name_home.append("/.qtradio/keys");
   file = new QFile(name_home);
    if ( ! file->exists() )
  {
    strcpy(&data_file[0], name_home);
    creat(&data_file[0], S_IWUSR | S_IRUSR);
      wyj = fopen(&data_file[0],"w");
      fprintf(wyj,"%s\n","F1");
      fprintf(wyj,"%s\n","F2");
      fprintf(wyj,"%s\n","K");
      fprintf(wyj,"%s\n","CTRL+E");
      fprintf(wyj,"%s\n","+");
      fprintf(wyj,"%s\n","Up");
      fprintf(wyj,"%s\n","-");
      fprintf(wyj,"%s\n","Down");
      fprintf(wyj,"%s\n","Right");
      fprintf(wyj,"%s\n","P");
      fprintf(wyj,"%s\n","Left");
      fprintf(wyj,"%s\n","S");
      fprintf(wyj,"%s\n","L");
      fprintf(wyj,"%s\n","CTRL+Left");
      fprintf(wyj,"%s\n","CTRL+Right");
      fclose(wyj);
  }
    // if file containing device's name doesn't exist  = create it
   name_home = home_dir();
   name_home.append("/.qtradio/settings");
   file = new QFile(name_home);
   if ( ! file->exists() )
    {
      strcpy(&data_file[0], name_home);
      creat(&data_file[0], S_IWUSR | S_IRUSR);
      //and save default config to file
      name_home = home_dir();
      name_home.append("/.qtradio/settings");
      strcpy(&data_file[0], name_home);
      wyj = fopen(&data_file[0],"w");
      fprintf(wyj,"%s\n","/dev/radio");
      fprintf(wyj,"%s\n","87");
      fprintf(wyj,"%s\n","108");
      fprintf(wyj,"%s\n","/dev/mixer");
      fprintf(wyj,"%s\n","line");
      fprintf(wyj,"%s\n","No");
      fprintf(wyj,"%s\n","DOCK=NO");
	  fprintf(wyj,"%s\n","0.2");
	  fprintf(wyj,"%s\n","3");		
      fclose(wyj);
    }
   


   // now we can read deivce's name from file
   file = new QFile(name_home);
   file->open(IO_ReadOnly);
   t = new QTextStream( file );
   strcpy( &device_name[0] , t->readLine() );
   for (i=0;i<=4;i++) t->readLine();//go to last line
   tmp = t->readLine();
   if ( tmp == "DOCK=YES" ) dock=TRUE;
   else dock=FALSE; 
   //printf("%s\n",&device_name[0]);
   file->close();

   // if file containing station's name doesn't exist  = create it
   name_home = home_dir();
   name_home.append("/.qtradio/programs");
   file = new QFile(name_home);      
    if ( ! file->exists() )
  {
    strcpy(&data_file[0], name_home);
    creat(&data_file[0], S_IWUSR | S_IRUSR);
  }

  // if file containing station's name on start doesn't exist  = create it
   name_home = home_dir();
   name_home.append("/.qtradio/start");
   file = new QFile(name_home);
    if ( ! file->exists() )
  {
    strcpy(&data_file[0], name_home);
    creat(&data_file[0], S_IWUSR | S_IRUSR);
     name_home = home_dir();
      wyj = fopen(&data_file[0],"w");
      fprintf(wyj,"%s\n","0");
      fprintf(wyj,"%s\n","50");
      fclose(wyj);
  }


   // now add stations from file to Combo      
   name_home = home_dir();
   name_home.append("/.qtradio/programs");
   file = new QFile(name_home);
   file->open(IO_ReadOnly);
   t = new QTextStream( file );
   i=0;
   while ( !t->atEnd()  )
    {
	    combo->insertItem( t->readLine(), -1) ;
  	  i++;
    }
    file->close();                             

  // if file containing station's frequency doesn't exist = create it                                     
  name_home = home_dir();
  name_home.append("/.qtradio/programs_freq");
  file = new QFile(name_home);
  if ( ! file->exists() )
  {
     strcpy(&data_file[0], name_home);
     creat(&data_file[0], S_IWUSR | S_IRUSR);
  }                                            

  // show main window and turn radio on
  name_home = "/usr/share/QtRadio/icons/qtradio.png";
 Radio->setIcon(QPixmap(name_home));
 
 if ( dock==FALSE ) 
 {
	 Radio->load_settings();
	 Radio->load_skin();
	 Radio->show();
 }
 else
{
	Radio->load_settings();
	 Radio->load_skin();
	 Radio->show();
	   	ti = new TrayIcon();
 	ti->show();
 }

               
  return a.exec();
}


