/***************************************************************************
                          qtradio.cpp  -  description
                             -------------------
    begin                : Sat Apr 12 00:32:39 CEST 2003
    copyright            : (C) 2003 by Pawel Pustelnik
    email                : pawelpus@wp.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "../config.h"


//Qt includes
#include <qaccel.h>
#include <qmotifstyle.h>
#include <qkeysequence.h>
#include <qcdestyle.h>
#include <qsgistyle.h>
#include <qvariant.h>
#include <qcombobox.h>
#include <qpainter.h>
#include <qlabel.h>
#include <qlcdnumber.h>
#include <qlineedit.h>
#include <qslider.h>
#include <qtoolbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qtimer.h>
#include <qdatetime.h>
#include <qlistview.h>
#include <qtextstream.h>
#include <qfile.h>
#include <qfileinfo.h>
#include <qdir.h>
#include <qevent.h>
#include <qregexp.h>
#include <qtabwidget.h>
#include <qframe.h>
#include <qtextedit.h>
#include <qspinbox.h>
#include <qimage.h>
#include <qpicture.h>
#include <qpixmap.h>
#include <qsocketnotifier.h>

//own includes
#include "qtradio.h"
#include "TrayIcon.h"
#include "radio_functions.c"
#include "home.h"

//system includes
#include <sys/soundcard.h>
#ifdef HAVE_LIRC
#include <lirc/lirc_client.h>
#endif

static int on = 1;
static QTimer *Timer;
QString nps,t;
QTime *Time;
QDate *Date;
int a = 0;
char device_name[50];
int DEVICE_MIX;    //name of main mixer label(line,vol etc)
char DEVICE_SND_MIX[150];//name of mixer device(/dev/mixer etc)
int LOWER=88;
int HIGHER=108;
int auto_raise;
int vol;
int box_ver;
int ver;
float dok=0.1;
int how_strength=2;
int NORMAL_SIZE_X,NORMAL_SIZE_Y,EXP_SIZE_X,EXP_SIZE_Y;
static bool active=FALSE;
QString pixmap_name;
QString data_config[60];
QString data_config_device[15];
QFont fontm;
QString SKIN_DIR;
QMouseEvent *e;
bool dockable=TRUE;
int prevx=0;
int prevy=0;
int ch=0;
QPoint diff;
QPixmap* num_1, *num_2, *num_3, *num_4, *num_5, *num_6, *num_7, *num_8, *num_9,*num_0; 
QPixmap* power_on, *power_off, *stereo_on, *stereo_off;
QPixmap* signal_0, *signal_1, *signal_2, *signal_3, *signal_4, *signal_5, *signal_6, *signal_7, *signal_8;
QString kseq[20];
QString names[20];
QPainter *painter;
int przes = 0;
int dlug = 0;
QImage *text;
QPicture *stringer;
QImage *part[200];
QImage *volumer;
QImage *led[50];
QImage *ltext;
QPixmap *pix;
int direction = 0;
int what = 0;
int motif = 1;

QPoint Main_pos;

int Freq_pos;
int Vol_pos;

int Freq_width;
int Vol_width;
int Freq_height;
int Vol_height;
int Freq_x;
int Freq_y;
int Vol_x;
int Vol_y;

int Vol_1_pos;
int Vol_2_pos;
int Vol_3_pos;
int Vol_4_pos;
int Vol_5_pos;
int Vol_6_pos;
int Vol_7_pos;
int Vol_8_pos;

int Vol_1_x,Vol_1_y,Vol_1_height;
int Vol_2_x,Vol_2_y,Vol_2_height;
int Vol_3_x,Vol_3_y,Vol_3_height;
int Vol_4_x,Vol_4_y,Vol_4_height;
int Vol_5_x,Vol_5_y,Vol_5_height;
int Vol_6_x,Vol_6_y,Vol_6_height;
int Vol_7_x,Vol_7_y,Vol_7_height;
int Vol_8_x,Vol_8_y,Vol_8_height;

int vol_size_x,vol_size_y,nexty;

QImage *Volume;
QImage *Frequency;
QImage *Number;
QImage *Signal_Led;
QImage *Main_button;
QImage *Window_button;
QImage *List_button;
QImage *Led;

QPixmap *about_pix;

static QSocketNotifier *sn;
static QTimer *TimerL;
static int lirc_fd = -1;
static int sockfd = 1;
#ifdef HAVE_LIRC
static struct lirc_config *config;
#endif


KDERadio::KDERadio(QWidget *parent, const char *name, WFlags f ) : QWidget(parent, name,WStyle_Customize | WStyle_NoBorder | WStyle_Tool)
{
    if ( !name )
	  setName( "QtRadio(0.8.1)" );

      setMouseTracking ( FALSE );
	  power_yes = 0;

    QFont font;
    font.setFamily("Helvetica");
    font.setPointSize(10);	  

    painter = new QPainter();
    stringer = new QPicture();
    pix = new QPixmap();
    Date = new QDate();
    Time = new QTime();
    Timer = new QTimer( this);
          	connect( Timer, SIGNAL(timeout()),
                 this, SLOT(nice_text()) );
    
    style = new QPopupMenu( this );
    style_dock = new QPopupMenu( this );
    style->setFont(font);
    style_dock->setFont(font);

    frame = new QFrame(this,"Frame");
  
    Previous_button = new QToolButton( this, "Previous_button" );
    Previous_button->setGeometry( QRect( 120, 40, 18, 18 ) );
    Previous_button->setPaletteBackgroundColor(QColor(0,0,0));

    Next_button = new QToolButton( this, "Next_button" );
    Next_button->setGeometry( QRect( 160, 40, 18, 18 ) );
    Next_button->setPaletteBackgroundColor(QColor(0,0,0));

    Close_button = new QToolButton( this, "Close_button" );
    Close_button->setGeometry( QRect( 423, 2, 8, 8 ) );
    
    Min_button = new QToolButton( this, "Min_button" );
    Min_button->setGeometry( QRect( 413, 2, 8, 8 ) );
    
    Move_button  = new QToolButton( this, "Move_button" );
    Move_button->setGeometry( QRect( 403, 2, 8, 8 ) );

    Freq_button = new QLabel( this, "Freq_button" );
    Freq_button->setMouseTracking(TRUE);

    Vol_button = new QLabel( this, "Vol_button" );
    Vol_button->setMouseTracking(TRUE);

    Vol_bar_1 = new QLabel( this, "Vol_bar_1" );

    Vol_bar_2 = new QLabel( this, "Vol_bar_2" );

    Vol_bar_3 = new QLabel( this, "Vol_bar_3" );

    Vol_bar_4 = new QLabel( this, "Vol_bar_4" );

    Vol_bar_5 = new QLabel( this, "Vol_bar_5" );

    Vol_bar_6 = new QLabel( this, "Vol_bar_6" );

    Vol_bar_7 = new QLabel( this, "Vol_bar_7" );

    Vol_bar_8 = new QLabel( this, "Vol_bar_8" );

    Vol_button_1 = new QLabel( this, "Vol_button_1" );
    Vol_button_1->setMouseTracking(TRUE);

    Vol_button_2 = new QLabel( this, "Vol_button_2" );
    Vol_button_2->setGeometry( QRect( 90, 55, 10, 5 ) );
    Vol_button_2->setMouseTracking(TRUE);

    Vol_button_3 = new QLabel( this, "Vol_button_3" );
    Vol_button_3->setGeometry( QRect( 90, 55, 10, 5 ) );
    Vol_button_3->setMouseTracking(TRUE);

    Vol_button_4 = new QLabel( this, "Vol_button_4" );
    Vol_button_4->setGeometry( QRect( 90, 55, 10, 5 ) );
    Vol_button_4->setMouseTracking(TRUE);

    Vol_button_5 = new QLabel( this, "Vol_button_5" );
    Vol_button_5->setGeometry( QRect( 90, 55, 10, 5 ) );
    Vol_button_5->setMouseTracking(TRUE);

    Vol_button_6 = new QLabel( this, "Vol_button_6" );
    Vol_button_6->setGeometry( QRect( 90, 55, 10, 5 ) );
    Vol_button_6->setMouseTracking(TRUE);

    Vol_button_7 = new QLabel( this, "Vol_button_7" );
    Vol_button_7->setGeometry( QRect( 90, 55, 10, 5 ) );
    Vol_button_7->setMouseTracking(TRUE);

    Vol_button_8 = new QLabel( this, "Vol_button_8" );
    Vol_button_8->setGeometry( QRect( 90, 55, 10, 5 ) );
    Vol_button_8->setMouseTracking(TRUE);

    Lista = new QComboBox( this, "Lista" );
    Lista->setGeometry( QRect( 0, 0, 0, 0 ) );

	
	One = new QLabel(this, "One");
	Two = new QLabel(this, "Two");
	Three = new QLabel(this, "Three");
	Four = new QLabel(this, "Four");
	Five = new QLabel(this, "Five");
	Power = new QLabel(this, "Power");	
	Stereo = new QLabel(this, "Stereo");
	Signal = new QLabel(this, "Signal");
	   
    
    Nicer = new QLabel( frame, "Nicer" );
    Nicer->setGeometry( QRect( 120, 10, 250, 24 ) );


    Saver_button = new QToolButton( this, "Saver_button" );
    Saver_button->setGeometry( QRect( 290, 95, 18, 18 ) );
    QFont Saver_button_font(  Saver_button->font() );
    Saver_button_font.setFamily( "Helvetica" );
    Saver_button_font.setPointSize( 10 );
    Saver_button->setFont( Saver_button_font );
    Saver_button->setPaletteBackgroundColor(QColor(0,0,0));

    Mixer_button = new QToolButton( this, "Mixer_button" );
    Mixer_button->setGeometry( QRect( 200, 95, 18, 18 ) );
    QFont Mixer_button_font(  Mixer_button->font() );
    Mixer_button_font.setFamily( "Helvetica" );
    Mixer_button_font.setPointSize( 10 );
    Mixer_button->setFont( Mixer_button_font );
    Mixer_button->setPaletteBackgroundColor(QColor(0,0,0));

    Rec_button = new QToolButton( this, "Rec_button" );
    Rec_button->setGeometry( QRect( 170, 95, 18, 18 ) );
    QFont Rec_button_font(  Rec_button->font() );
    Rec_button_font.setFamily( "Helvetica" );
    Rec_button_font.setPointSize( 10 );
    Rec_button->setFont( Rec_button_font );
    Rec_button->setPaletteBackgroundColor(QColor(0,0,0));

    Options_button = new QToolButton( this, "Options_button" );
    Options_button->setGeometry( QRect( 230, 95, 18, 18 ) );
    QFont Options_button_font(  Options_button->font() );
    Options_button_font.setFamily( "Helvetica" );
    Options_button_font.setPointSize( 10 );
    Options_button->setFont( Options_button_font );
    Options_button->setPaletteBackgroundColor(QColor(0,0,0));

    Seek_button = new QToolButton( this, "Seek_button" );
    Seek_button->setGeometry( QRect( 140, 95, 18, 18 ) );
    QFont Seek_button_font(  Seek_button->font() );
    Seek_button_font.setFamily( "Helvetica" );
    Seek_button_font.setPointSize( 10 );
    Seek_button->setFont( Seek_button_font );
    Seek_button->setPaletteBackgroundColor(QColor(0,0,0));

    Forward_long = new QToolButton( this, "Forward_long" );
    Forward_long->setGeometry( QRect( 110, 95, 18, 18 ) );
    QFont Forward_long_font(  Forward_long->font() );
    Forward_long_font.setFamily( "Helvetica" );
    Forward_long_font.setPointSize( 10 );
    Forward_long->setFont( Forward_long_font );
    Forward_long->setPaletteBackgroundColor(QColor(0,0,0));

    Reward_long = new QToolButton( this, "Reward_long" );
    Reward_long->setGeometry( QRect( 30, 95, 18, 18 ) );
    QFont Reward_long_font(  Reward_long->font() );
    Reward_long_font.setFamily( "Helvetica" );
    Reward_long_font.setPointSize( 10 );
    Reward_long->setFont( Reward_long_font );
    Reward_long->setPaletteBackgroundColor(QColor(0,0,0));

    Reward_short = new QToolButton( this, "Reward_short" );
    Reward_short->setGeometry( QRect( 56, 95, 18, 18 ) );
    QFont Reward_short_font(  Reward_short->font() );
    Reward_short_font.setFamily( "Helvetica" );
    Reward_short_font.setPointSize( 10 );
    Reward_short->setFont( Reward_short_font );
    Reward_short->setPaletteBackgroundColor(QColor(0,0,0));

    Forward_short = new QToolButton( this, "Forward_short" );
    Forward_short->setGeometry( QRect( 84, 95, 18, 18 ) );
    QFont Forward_short_font(  Forward_short->font() );
    Forward_short_font.setFamily( "Helvetica" );
    Forward_short_font.setPointSize( 10 );
    Forward_short->setFont( Forward_short_font );
    Forward_short->setPaletteBackgroundColor(QColor(0,0,0));

    Sound_mute = new QToolButton( this, "Sound_mute" );
    Sound_mute->setGeometry( QRect( 320, 95, 18, 18 ) );
    QFont Sound_mute_font(  Sound_mute->font() );
    Sound_mute_font.setFamily( "Helvetica" );
    Sound_mute_font.setPointSize( 10 );
    Sound_mute->setFont( Sound_mute_font );
    Sound_mute->setPaletteBackgroundColor(QColor(0,0,0));

    Switch_button = new QToolButton( this, "Switch_button" );
    Switch_button->setGeometry( QRect( 380, 96, 18, 18 ) );
    QFont Switch_button_font(  Switch_button->font() );
    Switch_button_font.setFamily( "Helvetica" );
    Switch_button_font.setPointSize( 10 );
    Switch_button->setFont( Switch_button_font );
    Switch_button->setPaletteBackgroundColor(QColor(0,0,0));
    
    signal_0 = new QPixmap();
    signal_1 = new QPixmap();
    signal_2 = new QPixmap();
    signal_3 = new QPixmap();
    signal_4 = new QPixmap();
    signal_5 = new QPixmap();
    signal_6 = new QPixmap();
    signal_7 = new QPixmap();
    signal_8 = new QPixmap();

    num_0 = new QPixmap();
    num_1 = new QPixmap();
    num_2 = new QPixmap();
    num_3 = new QPixmap();
    num_4 = new QPixmap();
    num_5 = new QPixmap();
    num_6 = new QPixmap();
    num_7 = new QPixmap();
    num_8 = new QPixmap();
    num_9 = new QPixmap();

    power_on = new QPixmap();
    power_off = new QPixmap();
    stereo_on = new QPixmap();
    stereo_off = new QPixmap();
    
    
    Previous_button->setBackgroundOrigin(ParentOrigin);
    Next_button->setBackgroundOrigin(ParentOrigin);
    Saver_button->setBackgroundOrigin(ParentOrigin);
    Mixer_button->setBackgroundOrigin(ParentOrigin);
    Rec_button->setBackgroundOrigin(ParentOrigin);
    Options_button->setBackgroundOrigin(ParentOrigin);
    Seek_button->setBackgroundOrigin(ParentOrigin);
    Switch_button->setBackgroundOrigin(ParentOrigin);
    Sound_mute->setBackgroundOrigin(ParentOrigin);
    Forward_long->setBackgroundOrigin(ParentOrigin);
    Forward_short->setBackgroundOrigin(ParentOrigin);
    Reward_long->setBackgroundOrigin(ParentOrigin);
    Reward_short->setBackgroundOrigin(ParentOrigin);
    

    QToolTip::add( Previous_button, tr( "Previous station" ) );
    QWhatsThis::add( Previous_button, tr( "Previous station" ) );

    QToolTip::add( Next_button, tr( "Next station" ) );
    QWhatsThis::add( Next_button, tr( "Next station" ) );

    QToolTip::add( Saver_button, tr( "Show station's list" ) );
    QWhatsThis::add( Saver_button, tr( "Show station's list" ) );

    QToolTip::add(Mixer_button , tr( "Show/Hide Mixer" ) );
    QWhatsThis::add( Mixer_button, tr( "Show/Hide Mixer" ) );

    QToolTip::add( Rec_button, tr( "Recording" ) );
    QWhatsThis::add( Rec_button, tr( "Recording" ) );

    QToolTip::add( Options_button, tr( "Setting's window" ) );
    QWhatsThis::add(Options_button , tr( "Setting's window" ) );

    QToolTip::add( Seek_button, tr( "Find new stations and save them" ) );
    QWhatsThis::add(Seek_button , tr( "Find new stations and save them" ) );

    QToolTip::add( Forward_long, tr( "Frequency + 0.1 MHz" ) );
    QWhatsThis::add(Forward_long , tr( "Frequency + 0.1 MHz" ) );
                                                       
    QToolTip::add(Reward_long , tr( "Frequency - 0.1 MHz" ) );
    QWhatsThis::add(Reward_long , tr( "Frequency - 0.1 MHz" ) );

    QToolTip::add(Reward_short , tr( "Frequency - 0.01 MHz" ) );
    QWhatsThis::add( Reward_short, tr( "Frequency - 0.01 MHz" ) );

    QToolTip::add(Forward_short , tr( "Frequency + 0.01 MHz" ) );
    QWhatsThis::add( Forward_short, tr( "Frequency + 0.01 MHz" ) );

    QToolTip::add(Sound_mute , tr( "Mute sound" ) );
    QWhatsThis::add(Sound_mute , tr( "Mute sound" ) );

    QToolTip::add( Switch_button, tr( "Power On/Off" ) );
    QWhatsThis::add(Switch_button , tr( "Powe On/Off" ) );
 							 
							 
    resize( QSize(433, 120).expandedTo(minimumSizeHint()) );
    // signals and slots connections
    connect( Lista, SIGNAL( activated(int) ), this, SLOT( Combo_on() ) );
    connect( Switch_button, SIGNAL( clicked() ), this, SLOT( Switcher() ) );
    connect( Sound_mute, SIGNAL( clicked() ), this, SLOT( mute_pressed() ) );
    connect( Forward_long, SIGNAL( clicked() ), this, SLOT( on_Forward() ) );
    connect( Reward_long, SIGNAL( clicked() ), this, SLOT( on_reward() ) );
    connect( Forward_short, SIGNAL( clicked() ), this, SLOT( short_Forward() ) );
    connect( Reward_short, SIGNAL( clicked() ), this, SLOT( short_reward() ) );
    connect( Rec_button, SIGNAL( clicked() ), this, SLOT( on_record() ) );
    connect( Mixer_button, SIGNAL( clicked() ), this, SLOT( on_mixer() ) );
    connect( Seek_button, SIGNAL( clicked() ), this, SLOT( on_seeking() ) );
    connect( Options_button, SIGNAL( clicked() ), this, SLOT( on_info() ) );
    connect( Next_button, SIGNAL( clicked() ), this, SLOT( next_station() ) );
    connect( Previous_button, SIGNAL( clicked() ), this, SLOT( prev_station() ) );
    connect( Close_button, SIGNAL( clicked() ), this, SLOT( close_main()) );
    connect( Move_button, SIGNAL( clicked() ), this, SLOT( move_main() ) );
    connect( Min_button, SIGNAL( clicked() ), this, SLOT( min_main() ) );
    connect( Saver_button, SIGNAL( clicked() ), this, SLOT( Save() ) );
    
}

void KDERadio::mousePressEvent(QMouseEvent * e)
{
	if (e->button() == RightButton)
	{
		style->exec(QCursor::pos());
	}

  if (e->button() == LeftButton)
  {
        Freq_pos = e->x() - Freq_button->x();
        Vol_pos = e->x() - Vol_button->x();
        Vol_1_pos = e->y() - Vol_button_1->y();
        Vol_2_pos = e->y() - Vol_button_2->y();
        Vol_3_pos = e->y() - Vol_button_3->y();
        Vol_4_pos = e->y() - Vol_button_4->y();
        Vol_5_pos = e->y() - Vol_button_5->y();
        Vol_6_pos = e->y() - Vol_button_6->y();
        Vol_7_pos = e->y() - Vol_button_7->y();
        Vol_8_pos = e->y() - Vol_button_8->y();

        Main_pos = e->pos() ;
    }
}

void KDERadio::mouseMoveEvent( QMouseEvent *e )
{	
       KDERadio::setMouseTracking(FALSE);
       
     
       if ( (e->x() >= Freq_button->x() ) && (e->x() <= Freq_button->x() + Freq_button->width()) && (e->y() >= Freq_button->y()) && (e->y() <=Freq_button->y() + Freq_button->height()) )
       {
          Freq_button->move(e->x() - Freq_pos,Freq_y);
          if (  Freq_button->x() <=  Freq_x)
            Freq_button->move(Freq_x,Freq_y);
          if (  Freq_button->x() >=  (Freq_x+Freq_width) )
            Freq_button->move( (Freq_x+Freq_width) ,Freq_y);
            Setting_new_freq();
        }

        else if ( (e->x() >= Vol_button->x() ) && (e->x() <= Vol_button->x() + Vol_button->width()) && (e->y() >= Vol_button->y()) && (e->y() <=Vol_button->y() + Vol_button->height()) )
       {
          Vol_button->move(e->x() - Vol_pos,Vol_y);
          if (  Vol_button->x() <=  Vol_x)
            Vol_button->move(Vol_x,Vol_y);
          if (  Vol_button->x() >=  (Vol_x+Vol_width) )
            Vol_button->move( (Vol_x+Vol_width) ,Vol_y);
            Setting_new_vol();
        }

        else if ( (e->x() >= Vol_button_1->x() ) && (e->x() <= Vol_button_1->x() + Vol_button_1->width()) && (e->y() >= Vol_button_1->y()) && (e->y() <=Vol_button_1->y() + Vol_button_1->height()) )
       {
          Vol_button_1->move(Vol_1_x, e->y()-Vol_1_pos);
          if (  Vol_button_1->y() <=  (Vol_1_y-Vol_1_height) )
            Vol_button_1->move(Vol_1_x,Vol_1_y-Vol_1_height); 
          if (  Vol_button_1->y() >=  (Vol_1_y) )
            Vol_button_1->move(  Vol_1_x , Vol_1_y );  
            new_vol_box1();
        }

         else if ( (e->x() >= Vol_button_2->x() ) && (e->x() <= Vol_button_2->x() + Vol_button_2->width()) && (e->y() >= Vol_button_2->y()) && (e->y() <=Vol_button_2->y() + Vol_button_2->height()) )
       {
           Vol_button_2->move(Vol_2_x, e->y()-Vol_2_pos);
          if (  Vol_button_2->y() <=  (Vol_2_y-Vol_2_height) )
            Vol_button_2->move(Vol_2_x,Vol_2_y-Vol_2_height);
          if (  Vol_button_2->y() >=  (Vol_2_y) )
            Vol_button_2->move(  Vol_2_x , Vol_2_y );  
            new_vol_box2();
        }

         else if ( (e->x() >= Vol_button_3->x() ) && (e->x() <= Vol_button_3->x() + Vol_button_3->width()) && (e->y() >= Vol_button_3->y()) && (e->y() <=Vol_button_3->y() + Vol_button_3->height()) )
       {
          Vol_button_3->move(Vol_3_x, e->y()-Vol_3_pos);
          if (  Vol_button_3->y() <=  (Vol_3_y-Vol_3_height) )
            Vol_button_3->move(Vol_3_x,Vol_3_y-Vol_3_height);
          if (  Vol_button_3->y() >=  (Vol_3_y) )
            Vol_button_3->move(  Vol_3_x , Vol_3_y );
            new_vol_box3();
        }

         else if ( (e->x() >= Vol_button_4->x() ) && (e->x() <= Vol_button_4->x() + Vol_button_4->width()) && (e->y() >= Vol_button_4->y()) && (e->y() <=Vol_button_4->y() + Vol_button_4->height()) )
       {
            Vol_button_4->move(Vol_4_x, e->y()-Vol_4_pos);
          if (  Vol_button_4->y() <=  (Vol_4_y-Vol_4_height) )
            Vol_button_4->move(Vol_4_x,Vol_4_y-Vol_4_height);
          if (  Vol_button_4->y() >=  (Vol_4_y) )
            Vol_button_4->move(  Vol_4_x , Vol_4_y );  
            new_vol_box4();
       }     

         else if ( (e->x() >= Vol_button_5->x() ) && (e->x() <= Vol_button_5->x() + Vol_button_5->width()) && (e->y() >= Vol_button_5->y()) && (e->y() <=Vol_button_5->y() + Vol_button_5->height()) )
       {
           Vol_button_5->move(Vol_5_x, e->y()-Vol_5_pos);
          if (  Vol_button_5->y() <=  (Vol_5_y-Vol_5_height) )
            Vol_button_5->move(Vol_5_x,Vol_5_y-Vol_5_height);
          if (  Vol_button_5->y() >=  (Vol_5_y) )
            Vol_button_5->move(  Vol_5_x , Vol_5_y );  
            new_vol_box5();
        }

         else if ( (e->x() >= Vol_button_6->x() ) && (e->x() <= Vol_button_6->x() + Vol_button_6->width()) && (e->y() >= Vol_button_6->y()) && (e->y() <=Vol_button_6->y() + Vol_button_6->height()) )
       {
           Vol_button_6->move(Vol_6_x, e->y()-Vol_6_pos);
          if (  Vol_button_6->y() <=  (Vol_6_y-Vol_6_height) )
            Vol_button_6->move(Vol_6_x,Vol_6_y-Vol_6_height);
          if (  Vol_button_6->y() >=  (Vol_6_y) )
            Vol_button_6->move(  Vol_6_x , Vol_6_y );  
            new_vol_box6();
        }

         else if ( (e->x() >= Vol_button_7->x() ) && (e->x() <= Vol_button_7->x() + Vol_button_7->width()) && (e->y() >= Vol_button_7->y()) && (e->y() <=Vol_button_7->y() + Vol_button_7->height()) )
       {
           Vol_button_7->move(Vol_7_x, e->y()-Vol_7_pos);
          if (  Vol_button_7->y() <=  (Vol_7_y-Vol_7_height) )
            Vol_button_7->move(Vol_7_x,Vol_7_y-Vol_7_height);
          if (  Vol_button_7->y() >=  (Vol_7_y) )
            Vol_button_7->move(  Vol_7_x , Vol_7_y );  
           new_vol_box7();
        }

         else if ( (e->x() >= Vol_button_8->x() ) && (e->x() <= Vol_button_8->x() + Vol_button_8->width()) && (e->y() >= Vol_button_8->y()) && (e->y() <=Vol_button_8->y() + Vol_button_8->height()) )
       {
            Vol_button_8->move(Vol_8_x, e->y()-Vol_8_pos);
          if (  Vol_button_8->y() <=  (Vol_8_y-Vol_8_height) )
            Vol_button_8->move(Vol_8_x,Vol_8_y-Vol_8_height);
          if (  Vol_button_8->y() >=  (Vol_8_y) )
            Vol_button_8->move(  Vol_8_x , Vol_8_y );  
            new_vol_box8();
        }

        else if ( e->y() <= 50 )
        {
          KDERadio::move(e->globalPos() - Main_pos );
          }
      
		e->accept(); 
}

//if quit clicked, before quiting close device
void KDERadio::closeEvent( QCloseEvent* ce )
{			
  char dane[150];
  QString name_home;
  FILE *wyj;
  
  close_radio(ver);
  close_mixer();
	
  name_home=home_dir();
  name_home.append("/.qtradio/start");
  strcpy(&dane[0], name_home);
  wyj = fopen(&dane[0], "w");
  fprintf(wyj,"%i\n",Lista->currentItem());
  fprintf(wyj,"%i\n", ( ((Vol_button->x())*1.0)/(Vol_width) )*100  );
  fclose(wyj);

  ce->accept();
  KDERadio::close();

}

//if quit clicked, before quiting close device
void KDERadio::on_exit()
{
  char dane[150];
  QString name_home;
  FILE *wyj;
  
  close_radio(ver);
  close_mixer();
  name_home=home_dir();
  name_home.append("/.qtradio/start");
  strcpy(&dane[0], name_home);
  wyj = fopen(&dane[0], "w");
  fprintf(wyj,"%i\n",Lista->currentItem());
  int bb = (100.0*(Vol_button->x()))/(Vol_width);
  	fprintf(wyj,"%i\n",bb  );
  fclose(wyj);

  if (sockfd == 1)
    {
      #ifdef HAVE_LIRC
      deinitialize_lirc();
      #endif
    }
  
  KDERadio::close();
}

void KDERadio::close_main()
{
  if ( dockable == FALSE )
  {
  	char dane[150];
  	QString name_home;
  	FILE *wyj;
  
  	close_radio(ver);
  	close_mixer();

  	name_home=home_dir();
  	name_home.append("/.qtradio/start");
  	strcpy(&dane[0], name_home);
  	wyj = fopen(&dane[0], "w");
  	fprintf(wyj,"%i\n",Lista->currentItem());
  	 int bb = (100.0*(Vol_button->x()))/(Vol_width);
  	fprintf(wyj,"%i\n",bb  );
  	fclose(wyj);

   if (sockfd == 1)
    {
      #ifdef HAVE_LIRC
      deinitialize_lirc();
      #endif
    }

	KDERadio::close();
  }
  else
  KDERadio::hide();
}

void KDERadio::min_main()
{
	KDERadio::showMinimized();
}

void KDERadio::Show_skin()
{
	Skin *sk = new Skin;
	QToolButton *btn;
	QFile *file;
	QTextStream *t;
	QString nps;


	QDir d;
	QListViewItem *item;
  	QListView *lst;
	lst = sk->SkinList;
	lst->setSorting(-1);

       	d.setFilter( QDir::Dirs );
       	d.setSorting( QDir::Name);
       	d.setPath("/usr/share/QtRadio/Skins/");
        const QFileInfoList *list = d.entryInfoList();
        QFileInfoListIterator it( *list );
        QFileInfo *fi;
	while ( (fi = it.current()) != 0 )
	{
	    nps = (fi->fileName().latin1() );
	    if ( ( nps != "/.." ) && ( nps != "/.") && !( nps =="." ) && !( nps ==".." ) )
	    {
		item = new QListViewItem(lst);
        	item->setText(0, nps);
		nps.prepend("/usr/share/QtRadio/Skins/");
		item->setText(1,nps);
	    }
	    ++it;
	}

	nps = home_dir();
	nps.append("/.qtradio/Skins");
	d.setPath(nps);
	list = d.entryInfoList();
	QFileInfoListIterator it2( *list );
	while ( (fi = it2.current()) != 0 )
	{
	   nps = (fi->fileName().latin1() );
	    if ( ( nps != "/.." ) && ( nps != "/.") && !( nps =="." ) && !( nps ==".." ) )
	    {
		item = new QListViewItem(lst);
        	item->setText(0, nps);
		nps.prepend("/.qtradio/Skins");
		nps.prepend(home_dir());
		item->setText(1,nps);
	    }
	    ++it2;
	}

	btn = sk->Close_button;
   	btn->setAutoRaise( Close_button->autoRaise());

   	sk->exec();

	nps = home_dir();
   	nps.append("/.qtradio/Skins/default");
   	file = new QFile(nps);
   	file->open(IO_ReadOnly);
   	t = new QTextStream( file );
   	SKIN_DIR = t->readLine();
   	file->close();
	load_skin();

	if ( active == TRUE)
	{
		Power->setPixmap(*power_on);
      	setting_leds_freq();
        setting_leds_signal();
		load_sound();
	}
}

void KDERadio::move_main()
{

	style->exec(QCursor::pos());
}


KDERadio::~KDERadio()
{

}


void KDERadio::Volume_up()
{

  if ( Vol_button->x() < (Vol_width+Vol_x) )
    Vol_button->move( Vol_button->x()+( Vol_width*0.1 ) ,Vol_y);
	Setting_new_vol();
}


void KDERadio::Volume_down()
{
  if ( Vol_button->x() > (Vol_x) )
	Vol_button->move( Vol_button->x()-( Vol_width*0.1 ) ,Vol_y);
	Setting_new_vol();
}

// set new volume when slider's value is changing
void KDERadio::Setting_new_vol()
{

  int i;
  QPixmap pix;
  
  vol = ( ((Vol_button->x() - Vol_x)*1.0)/(Vol_width)  ) *100;
  //printf("%i\n",vol);
  set_volume(vol, DEVICE_MIX);
  //other label also should move
	if ( DEVICE_MIX == 0)
  {
    Vol_button_1->move(Vol_1_x, (Vol_1_y  - ( (vol)*1.0/100)*(Vol_1_height) ) );
    for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i))  )
      *volumer = Volume->copy((vol_size_x+2)*i+1,0,vol_size_x,vol_size_y);
      }
    for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i+48))   )
      *volumer = Volume->copy((vol_size_x+2)*i+1,nexty,vol_size_x,vol_size_y);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_1->setPixmap(pix);
   }

   if ( DEVICE_MIX == 4)
   {
    Vol_button_2->move(Vol_2_x, (Vol_2_y  - ((vol)*1.0/100)*(Vol_2_height) ) );
      for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i))  )
      *volumer = Volume->copy((vol_size_x+2)*i+1,0,vol_size_x,vol_size_y);
      }
    for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i+48))   )
      *volumer = Volume->copy((vol_size_x+2)*i+1,nexty,vol_size_x,vol_size_y);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_2->setPixmap(pix);
    }

  if ( DEVICE_MIX == 5)
   {
      Vol_button_3->move(Vol_3_x, (Vol_3_y  - ((vol)*1.0/100)*(Vol_3_height) ) );
        for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i))  )
      *volumer = Volume->copy((vol_size_x+2)*i+1,0,vol_size_x,vol_size_y);
      }
    for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i+48))   )
      *volumer = Volume->copy((vol_size_x+2)*i+1,nexty,vol_size_x,vol_size_y);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_3->setPixmap(pix);
    }

  if ( DEVICE_MIX == 6)
  {
    Vol_button_4->move(Vol_4_x, (Vol_4_y  - ((vol)*1.0/100)*(Vol_4_height) ) );
      for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i))  )
      *volumer = Volume->copy((vol_size_x+2)*i+1,0,vol_size_x,vol_size_y);
      }
    for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i+48))   )
      *volumer = Volume->copy((vol_size_x+2)*i+1,nexty,vol_size_x,vol_size_y);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_4->setPixmap(pix);
   }

  if ( DEVICE_MIX == 7)
   {
    Vol_button_5->move(Vol_5_x, (Vol_5_y  - ((vol)*1.0/100)*(Vol_5_height) ) );
      for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i))  )
      *volumer = Volume->copy((vol_size_x+2)*i+1,0,vol_size_x,vol_size_y);
      }
    for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i+48))   )
      *volumer = Volume->copy((vol_size_x+2)*i+1,nexty,vol_size_x,vol_size_y);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_5->setPixmap(pix);
    }

  if ( DEVICE_MIX == 8)
   {
    Vol_button_6->move(Vol_6_x, (Vol_6_y  - ((vol)*1.0/100)*(Vol_6_height) ) );
     for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i))  )
      *volumer = Volume->copy((vol_size_x+2)*i+1,0,vol_size_x,vol_size_y);
      }
    for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i+48))   )
      *volumer = Volume->copy((vol_size_x+2)*i+1,nexty,vol_size_x,vol_size_y);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_6->setPixmap(pix);
   }

  if ( DEVICE_MIX == 22)
    {
      Vol_button_7->move(Vol_7_x, (Vol_7_y  - ((vol)*1.0/100)*(Vol_7_height) ) );
        for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i))  )
      *volumer = Volume->copy((vol_size_x+2)*i+1,0,vol_size_x,vol_size_y);
      }
    for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i+48))   )
      *volumer = Volume->copy((vol_size_x+2)*i+1,nexty,vol_size_x,vol_size_y);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_7->setPixmap(pix);
     }

  if ( DEVICE_MIX == 14)
   {
      Vol_button_8->move(Vol_8_x, (Vol_8_y  - ((vol)*1.0/100)*(Vol_8_height) ) );
        for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i))  )
      *volumer = Volume->copy((vol_size_x+2)*i+1,0,vol_size_x,vol_size_y);
      }
    for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i+48))   )
      *volumer = Volume->copy((vol_size_x+2)*i+1,nexty,vol_size_x,vol_size_y);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_8->setPixmap(pix);
   }

}

// set new frequency when slider's value is changing
void KDERadio::Setting_new_freq()
{


    freq = ( ((Freq_button->x() - Freq_x)*1.0)/Freq_width )*(HIGHER-LOWER) + 1.0*LOWER;
    printf("%.2f\n",freq);

    New_text();

    przes = 4*dlug-1;
    motif = 2;
    direction = 0;

    setting_leds_signal();//show signal's strength
    setting_leds_freq();  //show signal's value

}

// muting
void KDERadio::mute_pressed()
{
    if ( on == 1)
    {
	     mute(ver);
	     on = 0;
    }
    else
    {
	    unmute(ver);
	    on = 1;
    }
}

// open station's window
void KDERadio::Save()
{
  int i;
  QListViewItem *item;
  QListView *list;
  QLabel *label;
  QFile *file;
  QLineEdit *ld;
  QToolButton *btn;
  QListView* lw;
  QTextStream *t;
  Add *ad = new Add;
  QString name[260];
  QString value[260];
  QString name_home;

  name_home = home_dir();
  name_home.append("/.qtradio/programs");

  list = ad->Station_list;
  list->setSorting(-1);

  file = new QFile(name_home);
  file->open(IO_ReadOnly );
  t = new QTextStream( file );

  i=0;
   while ( !t->atEnd() )
   {
       name[i+1] = t->readLine();
       i++;
  }
  file->close();

  name_home = home_dir();
  name_home.append("/.qtradio/programs_freq");
  file = new QFile(name_home);
  file->open(IO_ReadOnly );
  t = new QTextStream( file );

  i=0;
   while ( !t->atEnd() )
   {
       value[i+1] = t->readLine();
       i++;
   }
  file->close();

    label=ad->Label_how_many;
    label->setText( QString::number(i) );
    while (i>0)
    {
        item = new QListViewItem(list);
        item->setText(0, name[i]);
        item->setText(1, value[i]);
        i--;
    }

   ld = ad->Freq_edit;
   ld->setText(QString::number(freq, 'f', 2));

   btn = ad->Add_button;


   btn = ad->Edit_button;
 

   btn = ad->Quit_button;


   btn = ad->Rem_button;


   btn = ad->Save_button;;



   ad->show();



}

// when combo clicked
void KDERadio::Combo_on()
{
    //list_load();

    FILE *wej;
    char dane[50];
    int i;
    QString name_home;
    name_home = home_dir();
    name_home.append("/.qtradio/programs");

    // read station's name from combo
    // and its frequency
    QFile *file;
    QTextStream *t;
    file = new QFile(name_home);
    file->open(IO_ReadOnly );
    t = new QTextStream( file );
    i=0;
    while ( !t->atEnd() )
    {
    	if ( Lista->currentText() == t->readLine() ) break;
      i++;
    }
    file->close();
    // now I know station's number

    name_home = home_dir();
    name_home.append("/.qtradio/programs_freq");
    strcpy(&dane[0],name_home);
    wej = fopen(&dane[0],"r");

    //printf("%i\n",i);
    while ( i>=0)
    {
	    fscanf(wej, "%f\n",&freq);//now frequency
        i--;
    }
    fclose(wej);

    setting_leds_signal();
    setting_leds_freq();

    New_text();

    przes = 4*dlug-1;
    motif = 2;
    direction = 0;

}


void KDERadio::Volume_set()
{

}

void KDERadio::Power_S()
{

	load_settings();
	load_skin();
	Switcher();
	power_yes = 1;
}

void KDERadio::Save_data()
{
	QString dest;
	char dane[50];
	FILE *wyj;

	dest = home_dir();
    dest.append("/.qtradio/start");
	strcpy(&dane[0], dest);
  	wyj = fopen(&dane[0], "w");
  	fprintf(wyj,"%i\n",Lista->currentItem());
   int bb = (100.0*(Vol_button->x()-Vol_x))/(Vol_width);
  	fprintf(wyj,"%i\n",bb  );
  	fclose(wyj);

}

// whem main switch is clicked
void KDERadio::Switcher()
{

	if ( active == TRUE)
	{
		Power->setPixmap(*power_off);
      Signal->setPixmap(*signal_0);
      freq=0;
      setting_leds_freq();
      Stereo->setPixmap(*stereo_off);
      active = FALSE;
		close_radio(ver);
     	close_mixer();
		Save_data();
      Timer->stop();
      painter->begin(Nicer);
      painter->eraseRect(0,0,Nicer->width(),Nicer->height());
      painter->end();
      Nicer->clear();
	}

  	else
    {

		device_name_show();//read device's name

      	station_name = "None";

          load_skin();

          load_settings();//load all settings

		    list_load();//load station's list


      	if ( init_mixer(&DEVICE_SND_MIX[0]) != 1)
      	{
        	nps = (tr("Can't open mixer device : "));
        	nps.append(&DEVICE_SND_MIX[0]);
			nps.append(" => Mixer is off");
        	QMessageBox::information( this, "QtRadio",nps);
        	//return;
      	}
      else
      {
        set_volume(vol, DEVICE_MIX);//set previous volume
        load_sound();//load previous volume value
	  }

		ver = version(&device_name[0]);

        if ( initialize( ver ) != 1 )
	 	{
          nps = (tr("Can't open radio device : "));
          nps.append(&device_name[0]);
		  nps.append(" => Radio Tuner is off");
          QMessageBox::information( this, "QtRadio",nps);
          //return ;
		}

	   	  	unmute(ver);
	   	  	Power->setPixmap(*power_on);
			freq = 108;
		  	active = TRUE;
          	set_scale();
          	setting_leds_freq();
          	setting_leds_signal();
			list_load();//load station's list
		     // timer for edit above slider, showing frequency and time etc
            przes = 0;
            what = 0;
            direction = 0;
            Timer->start(30);
             #ifdef HAVE_LIRC
             if ( !initialize_lirc() ) printf("Can't initialize LIRC");
	          else
	          start_lirc();
            #endif


    }

}

// add 0.1 to current frequency
void KDERadio::on_Forward()
{
    if ( freq < (1.0*HIGHER))
    {
	     freq = freq+0.1;
       	 setting_leds_freq();
     }
     setting_leds_signal();
}

// sub 0.1 to current frequency
void KDERadio::on_reward()
{
    if ( freq > (1.0*LOWER))
    {
	    freq =freq-0.1;
      	setting_leds_freq();
     }
     setting_leds_signal();
}

// sub 0.01 to current frequency
void KDERadio::short_reward()
{
    if ( freq > (1.0*LOWER) )
    {
	    freq = freq - 0.01;
      	setting_leds_freq();
     }
     setting_leds_signal();
}

// add 0.01 to current frequency
void KDERadio::short_Forward()
{
    if ( freq < (1.0*HIGHER) )
    {
	    freq = freq + 0.01;
      	setting_leds_freq();
     }
     setting_leds_signal();
}

//show frequency in LCD view
void KDERadio::setting_leds_freq()
{
 int temper;
 QString nps;
 QString temp_nps;

  temper = freq/100;

	if ( freq < 100.0 )
	{
      nps = QString::number(freq,'f',3);
      nps.insert(0,"0");

      temp_nps = nps;
      temp_nps = temp_nps.remove(1,6);
      if ( temp_nps.toInt() == 0 )
		  One->setPixmap(*num_0);
	  if ( temp_nps.toInt() == 1 )
		  One->setPixmap(*num_1);
	  if ( temp_nps.toInt() == 2 )
		  One->setPixmap(*num_2);
	  if ( temp_nps.toInt() == 3 )
		  One->setPixmap(*num_3);
	  if ( temp_nps.toInt() == 4 )
		  One->setPixmap(*num_4);
	  if ( temp_nps.toInt() == 5 )
		  One->setPixmap(*num_5);
	  if ( temp_nps.toInt() == 6 )
		  One->setPixmap(*num_6);
	  if ( temp_nps.toInt() == 7 )
		  One->setPixmap(*num_7);
	  if ( temp_nps.toInt() == 8 )
		  One->setPixmap(*num_8);
	  if ( temp_nps.toInt() == 9 )
		  One->setPixmap(*num_9);

      temp_nps = nps;
      temp_nps = temp_nps.remove(0,1);
      temp_nps = temp_nps.remove(1,5);
	  if ( temp_nps.toInt() == 0 )
		  Two->setPixmap(*num_0);
	  if ( temp_nps.toInt() == 1 )
		  Two->setPixmap(*num_1);
	  if ( temp_nps.toInt() == 2 )
		  Two->setPixmap(*num_2);
	  if ( temp_nps.toInt() == 3 )
		  Two->setPixmap(*num_3);
	  if ( temp_nps.toInt() == 4 )
		  Two->setPixmap(*num_4);
	  if ( temp_nps.toInt() == 5 )
		  Two->setPixmap(*num_5);
	  if ( temp_nps.toInt() == 6 )
		  Two->setPixmap(*num_6);
	  if ( temp_nps.toInt() == 7 )
		  Two->setPixmap(*num_7);
	  if ( temp_nps.toInt() == 8 )
		  Two->setPixmap(*num_8);
	  if ( temp_nps.toInt() == 9 )
		  Two->setPixmap(*num_9);


      temp_nps = nps;
      temp_nps = temp_nps.remove(0,2);
      temp_nps = temp_nps.remove(1,4);
      if ( temp_nps.toInt() == 0 )
		  Three->setPixmap(*num_0);
	  if ( temp_nps.toInt() == 1 )
		  Three->setPixmap(*num_1);
	  if ( temp_nps.toInt() == 2 )
		  Three->setPixmap(*num_2);
	  if ( temp_nps.toInt() == 3 )
		  Three->setPixmap(*num_3);
	  if ( temp_nps.toInt() == 4 )
		  Three->setPixmap(*num_4);
	  if ( temp_nps.toInt() == 5 )
		  Three->setPixmap(*num_5);
	  if ( temp_nps.toInt() == 6 )
		  Three->setPixmap(*num_6);
	  if ( temp_nps.toInt() == 7 )
		  Three->setPixmap(*num_7);
	  if ( temp_nps.toInt() == 8 )
		  Three->setPixmap(*num_8);
	  if ( temp_nps.toInt() == 9 )
		  Three->setPixmap(*num_9);

      temp_nps = nps;
      temp_nps = temp_nps.remove(0,4);
      temp_nps = temp_nps.remove(1,2);
      if ( temp_nps.toInt() == 0 )
		  Four->setPixmap(*num_0);
	  if ( temp_nps.toInt() == 1 )
		  Four->setPixmap(*num_1);
	  if ( temp_nps.toInt() == 2 )
		  Four->setPixmap(*num_2);
	  if ( temp_nps.toInt() == 3 )
		  Four->setPixmap(*num_3);
	  if ( temp_nps.toInt() == 4 )
		  Four->setPixmap(*num_4);
	  if ( temp_nps.toInt() == 5 )
		  Four->setPixmap(*num_5);
	  if ( temp_nps.toInt() == 6 )
		  Four->setPixmap(*num_6);
	  if ( temp_nps.toInt() == 7 )
		  Four->setPixmap(*num_7);
	  if ( temp_nps.toInt() == 8 )
		  Four->setPixmap(*num_8);
	  if ( temp_nps.toInt() == 9 )
		  Four->setPixmap(*num_9);

      temp_nps = nps;
      temp_nps = temp_nps.remove(0,6);
      temper = temp_nps.toInt();
      if ( temper >=5 )
      {
          temp_nps = nps;
          temp_nps = temp_nps.remove(0,5);
          temp_nps = temp_nps.remove(1,1);
          if ( temp_nps.toInt() == 0 )
		  Five->setPixmap(*num_0);
	  	if ( temp_nps.toInt() == 1 )
		  Five->setPixmap(*num_1);
	  	if ( temp_nps.toInt() == 2 )
		  Five->setPixmap(*num_2);
	  	if ( temp_nps.toInt() == 3 )
			Five->setPixmap(*num_3);
	 	 if ( temp_nps.toInt() == 4 )
		  Five->setPixmap(*num_4);
	  	if ( temp_nps.toInt() == 5 )
		  Five->setPixmap(*num_5);
	  	if ( temp_nps.toInt() == 6 )
		  Five->setPixmap(*num_6);
	  	if ( temp_nps.toInt() == 7 )
		  Five->setPixmap(*num_7);
	  	if ( temp_nps.toInt() == 8 )
		  Five->setPixmap(*num_8);
	 	 if ( temp_nps.toInt() == 9 )
		  Five->setPixmap(*num_9);
      }
      else
      {
          temp_nps = nps;
          temp_nps = temp_nps.remove(0,5);
          temp_nps = temp_nps.remove(1,1);
          if ( temp_nps.toInt() == 0 )
		  Five->setPixmap(*num_0);
	  	if ( temp_nps.toInt() == 1 )
		  Five->setPixmap(*num_1);
	 	 if ( temp_nps.toInt() == 2 )
		  Five->setPixmap(*num_2);
	  	if ( temp_nps.toInt() == 3 )
		  Five->setPixmap(*num_3);
	  	if ( temp_nps.toInt() == 4 )
		  Five->setPixmap(*num_4);
	  	if ( temp_nps.toInt() == 5 )
		  Five->setPixmap(*num_5);
	  	if ( temp_nps.toInt() == 6 )
		  Five->setPixmap(*num_6);
	  	if ( temp_nps.toInt() == 7 )
		  Five->setPixmap(*num_7);
	  	if ( temp_nps.toInt() == 8 )
		  Five->setPixmap(*num_8);
	  	if ( temp_nps.toInt() == 9 )
		  Five->setPixmap(*num_9);
      }

	}
	else
	{
        nps = QString::number(freq,'f',3);

      temp_nps = nps;
      temp_nps = temp_nps.remove(1,6);
      if ( temp_nps.toInt() == 0 )
		  One->setPixmap(*num_0);
	  if ( temp_nps.toInt() == 1 )
		  One->setPixmap(*num_1);
	  if ( temp_nps.toInt() == 2 )
		  One->setPixmap(*num_2);
	  if ( temp_nps.toInt() == 3 )
		  One->setPixmap(*num_3);
	  if ( temp_nps.toInt() == 4 )
		  One->setPixmap(*num_4);
	  if ( temp_nps.toInt() == 5 )
		  One->setPixmap(*num_5);
	  if ( temp_nps.toInt() == 6 )
		  One->setPixmap(*num_6);
	  if ( temp_nps.toInt() == 7 )
		  One->setPixmap(*num_7);
	  if ( temp_nps.toInt() == 8 )
		  One->setPixmap(*num_8);
	  if ( temp_nps.toInt() == 9 )
		  One->setPixmap(*num_9);

      temp_nps = nps;
      temp_nps = temp_nps.remove(0,1);
      temp_nps = temp_nps.remove(1,5);
	  if ( temp_nps.toInt() == 0 )
		  Two->setPixmap(*num_0);
	  if ( temp_nps.toInt() == 1 )
		  Two->setPixmap(*num_1);
	  if ( temp_nps.toInt() == 2 )
		  Two->setPixmap(*num_2);
	  if ( temp_nps.toInt() == 3 )
		  Two->setPixmap(*num_3);
	  if ( temp_nps.toInt() == 4 )
		  Two->setPixmap(*num_4);
	  if ( temp_nps.toInt() == 5 )
		  Two->setPixmap(*num_5);
	  if ( temp_nps.toInt() == 6 )
		  Two->setPixmap(*num_6);
	  if ( temp_nps.toInt() == 7 )
		  Two->setPixmap(*num_7);
	  if ( temp_nps.toInt() == 8 )
		  Two->setPixmap(*num_8);
	  if ( temp_nps.toInt() == 9 )
		  Two->setPixmap(*num_9);


      temp_nps = nps;
      temp_nps = temp_nps.remove(0,2);
      temp_nps = temp_nps.remove(1,4);
      if ( temp_nps.toInt() == 0 )
		  Three->setPixmap(*num_0);
	  if ( temp_nps.toInt() == 1 )
		  Three->setPixmap(*num_1);
	  if ( temp_nps.toInt() == 2 )
		  Three->setPixmap(*num_2);
	  if ( temp_nps.toInt() == 3 )
		  Three->setPixmap(*num_3);
	  if ( temp_nps.toInt() == 4 )
		  Three->setPixmap(*num_4);
	  if ( temp_nps.toInt() == 5 )
		  Three->setPixmap(*num_5);
	  if ( temp_nps.toInt() == 6 )
		  Three->setPixmap(*num_6);
	  if ( temp_nps.toInt() == 7 )
		  Three->setPixmap(*num_7);
	  if ( temp_nps.toInt() == 8 )
		  Three->setPixmap(*num_8);
	  if ( temp_nps.toInt() == 9 )
		  Three->setPixmap(*num_9);

      temp_nps = nps;
      temp_nps = temp_nps.remove(0,4);
      temp_nps = temp_nps.remove(1,2);
      if ( temp_nps.toInt() == 0 )
		  Four->setPixmap(*num_0);
	  if ( temp_nps.toInt() == 1 )
		  Four->setPixmap(*num_1);
	  if ( temp_nps.toInt() == 2 )
		  Four->setPixmap(*num_2);
	  if ( temp_nps.toInt() == 3 )
		  Four->setPixmap(*num_3);
	  if ( temp_nps.toInt() == 4 )
		  Four->setPixmap(*num_4);
	  if ( temp_nps.toInt() == 5 )
		  Four->setPixmap(*num_5);
	  if ( temp_nps.toInt() == 6 )
		  Four->setPixmap(*num_6);
	  if ( temp_nps.toInt() == 7 )
		  Four->setPixmap(*num_7);
	  if ( temp_nps.toInt() == 8 )
		  Four->setPixmap(*num_8);
	  if ( temp_nps.toInt() == 9 )
		  Four->setPixmap(*num_9);

      temp_nps = nps;
      temp_nps = temp_nps.remove(0,6);
      temper = temp_nps.toInt();
      if ( temper >=5 )
      {
          temp_nps = nps;
          temp_nps = temp_nps.remove(0,5);
          temp_nps = temp_nps.remove(1,1);
          if ( temp_nps.toInt() == 0 )
		  Five->setPixmap(*num_0);
	  	if ( temp_nps.toInt() == 1 )
		  Five->setPixmap(*num_1);
	  	if ( temp_nps.toInt() == 2 )
		  Five->setPixmap(*num_2);
	  	if ( temp_nps.toInt() == 3 )
			Five->setPixmap(*num_3);
	 	 if ( temp_nps.toInt() == 4 )
		  Five->setPixmap(*num_4);
	  	if ( temp_nps.toInt() == 5 )
		  Five->setPixmap(*num_5);
	  	if ( temp_nps.toInt() == 6 )
		  Five->setPixmap(*num_6);
	  	if ( temp_nps.toInt() == 7 )
		  Five->setPixmap(*num_7);
	  	if ( temp_nps.toInt() == 8 )
		  Five->setPixmap(*num_8);
	 	 if ( temp_nps.toInt() == 9 )
		  Five->setPixmap(*num_9);
      }
      else
      {
          temp_nps = nps;
          temp_nps = temp_nps.remove(0,5);
          temp_nps = temp_nps.remove(1,1);
          if ( temp_nps.toInt() == 0 )
		  Five->setPixmap(*num_0);
	  	if ( temp_nps.toInt() == 1 )
		  Five->setPixmap(*num_1);
	 	 if ( temp_nps.toInt() == 2 )
		  Five->setPixmap(*num_2);
	  	if ( temp_nps.toInt() == 3 )
		  Five->setPixmap(*num_3);
	  	if ( temp_nps.toInt() == 4 )
		  Five->setPixmap(*num_4);
	  	if ( temp_nps.toInt() == 5 )
		  Five->setPixmap(*num_5);
	  	if ( temp_nps.toInt() == 6 )
		  Five->setPixmap(*num_6);
	  	if ( temp_nps.toInt() == 7 )
		  Five->setPixmap(*num_7);
	  	if ( temp_nps.toInt() == 8 )
		  Five->setPixmap(*num_8);
	  	if ( temp_nps.toInt() == 9 )
		  Five->setPixmap(*num_9);
      }
	}

	setting_frequency(freq,ver);

  // turn red led on if stereo
	if ( stereo_checking(ver) == 0)
	    Stereo->setPixmap(*stereo_off);
	if ( stereo_checking(ver) == 1)
	     Stereo->setPixmap(*stereo_on);

   Freq_button->move( Freq_x + ((freq-LOWER)/(HIGHER-LOWER))*(Freq_width)   ,Freq_y);

}

// show strength of signal
void KDERadio::setting_leds_signal()
{
    int checker = signal_strength(ver);
	//printf("Signal strength = %i\n",checker);
	Signal->setPixmap(*signal_0);

	if ( checker >= (1) ) Signal->setPixmap(*signal_1);

	if ( checker >= (2) ) Signal->setPixmap(*signal_2);

	if ( checker >= (3) ) Signal->setPixmap(*signal_3);

	if ( checker >= (4) ) Signal->setPixmap(*signal_4);

	if ( checker >= (5) ) Signal->setPixmap(*signal_5);

	if ( checker >= (6) ) Signal->setPixmap(*signal_6);

	if ( checker >= (7) ) Signal->setPixmap(*signal_7);

	if ( checker >= (7) ) Signal->setPixmap(*signal_8);
}


void KDERadio::Setting_new_freq_dok()
{

}


void KDERadio::New_text()
{

    int i = 0;


    station_name =  Lista->currentText();

    if (direction == 0)
    {
      nps = "";
      nps.append( QString::number(freq,'f',2) );
      nps.append(" MHz ");
      nps.append("* ");
      nps.append(station_name);
    }

    if (direction == 1)
    {
      nps = "* ";
      nps.append( Date->currentDate().toString( Qt::TextDate ) );
      nps.append(" * ");
      nps.append( (Time->currentTime()).toString(Qt::TextDate) );
      nps.append(" * ");
    }

    if (direction == 2)
    {
        nps = "QtRadio 0.8.1 [Feb 2004]";
    }

     if (direction == 3)
    {
        nps = "News at http://linux.perlak.com";
    }

    i = 0;
    QString s;

    do
    {
        s = nps.left(1);
        nps.remove(0,1);

        if ( (s == "A") || (s == "a") )
        {
            *part[i] = text->copy(0,0,6,8);
          }

         if ( (s == "B") || (s == "b") )
        {
            *part[i] = text->copy(7,0,6,8);
          }

          if ( (s == "C") || (s == "c") )
        {
            *part[i] = text->copy(14,0,6,8);
          }

          if ( (s == "D") || (s == "d") )
        {
            *part[i] = text->copy(21,0,6,8);
          }

          if ( (s == "E") || (s == "e") )
        {
            *part[i] = text->copy(28,0,6,8);
          }

          if ( (s == "F") || (s == "f") )
        {
            *part[i] = text->copy(35,0,6,8);
          }
           if ( (s == "G") || (s == "g") )
        {
            *part[i] = text->copy(42,0,6,8);
          }

          if ( (s == "H") || (s == "h") )
        {
            *part[i] = text->copy(49,0,6,8);
          }

           if ( (s == "I") || (s == "i") )
        {
            *part[i] = text->copy(56,0,6,8);
          }

          if ( (s == "J") || (s == "j") )
        {
            *part[i] = text->copy(63,0,6,8);
          }

           if ( (s == "K") || (s == "k") )
        {
            *part[i] = text->copy(70,0,6,8);
          }

            if ( (s == "L") || (s == "l") )
        {
            *part[i] = text->copy(77,0,6,8);
          }

          if ( (s == "M") || (s == "m") )
        {
            *part[i] = text->copy(84,0,6,8);
          }

            if ( (s == "N") || (s == "n") )
        {
            *part[i] = text->copy(91,0,6,8);
          }

            if ( (s == "O") || (s == "o") )
        {
            *part[i] = text->copy(98,0,6,8);
          }

            if ( (s == "P") || (s == "p") )
        {
            *part[i] = text->copy(105,0,6,8);
          }

            if ( (s == "Q") || (s == "q") )
        {
            *part[i] = text->copy(112,0,6,8);
          }
          
            if ( (s == "R") || (s == "r") )
        {
            *part[i] = text->copy(119,0,6,8);
          }

             if ( (s == "S") || (s == "s") )
        {
            *part[i] = text->copy(126,0,6,8);
          }

           if ( (s == "T") || (s == "t") )
        {
            *part[i] = text->copy(133,0,6,8);
          }

            if ( (s == "U") || (s == "u") )
        {
            *part[i] = text->copy(140,0,6,8);
          }

           if ( (s == "V") || (s == "v") )
        {
            *part[i] = text->copy(147,0,6,8);
          }

            if ( (s == "W") || (s == "w") )
        {
            *part[i] = text->copy(154,0,6,8);
          }

           if ( (s == "X") || (s == "x") )
        {
            *part[i] = text->copy(161,0,6,8);
          }

           if ( (s == "Y") || (s == "y") )
        {
            *part[i] = text->copy(168,0,6,8);
          }

             if ( (s == "Z") || (s == "z") )
        {
            *part[i] = text->copy(175,0,6,8);
          }

            if ( s == "*" )
        {
            *part[i] = text->copy(223,0,6,8);
          }

          if ( s == " " )
        {
            *part[i] = text->copy(237,0,6,8);
          }

            if ( s == "0" )
        {
            *part[i] = text->copy(0,9,6,8);
          }

        if ( s == "1" )
        {
            *part[i] = text->copy(7,9,6,8);
          }

         if ( s == "2" )
        {
            *part[i] = text->copy(14,9,6,8);
          }

        if ( s == "3" )
        {
            *part[i] = text->copy(21,9,6,8);
          }

        if ( s == "4" )
        {
            *part[i] = text->copy(28,9,6,8);
          }

         if ( s == "5" )
        {
            *part[i] = text->copy(35,9,6,8);
          }
          if ( s == "6" )
        {
            *part[i] = text->copy(42,9,6,8);
          }

        if ( s == "7" )
        {
            *part[i] = text->copy(49,9,6,8);
          }

         if ( s == "8" )
        {
            *part[i] = text->copy(56,9,6,8);
          }

         if ( s == "9" )
        {
            *part[i] = text->copy(63,9,6,8);
          }

           if ( s == ":" )
        {
            *part[i] = text->copy(230,0,6,8);
          }

          if ( s == "." )
        {
            *part[i] = text->copy(244,0,6,8);
          }

           if ( s == "[" )
        {
            *part[i] = text->copy(209,0,6,8);
          }

          if ( s == "]" )
        {
            *part[i] = text->copy(216,0,6,8);
          }

          if ( s == "!" )
        {
            *part[i] = text->copy(202,0,6,8);
          }

           if ( s == "/" )
        {
            *part[i] = text->copy(187,0,6,8);
          }


          i++;

      } while ( nps.length() > 0 );


    dlug = i;

}

// nice text above slider
void KDERadio::nice_text()
{

      if ( motif == 1) //text moving here and back
      {

       if ( (przes <= 10) && (przes>0) )
       {
           Nicer->setGeometry(Nicer->x()-1, 0, Nicer->width(), Nicer->height() );
         }

       if ( (przes > 10) && ( przes <= 20) )
       {
           Nicer->setGeometry(Nicer->x()+1, 0, Nicer->width(), Nicer->height() );
           if (przes == 20)
            przes = 0;
         }

          przes++;

       }


       if ( motif == 2)
       {
            if (direction == 0)
            {

              if ( (przes < (dlug) )  )
              {
                painter->begin(Nicer);
                painter->drawImage( przes*7+7, 0,*part[ przes ] );
                painter->end();
                przes++;
              }
              else
              {
                 przes++;
                 if (przes == 4*dlug)
                 {
                   painter->begin(Nicer);
                   painter->eraseRect(QRect(0,0,Nicer->width(),Nicer->height()) );
                   painter->end();
                   direction = 1;
                   New_text();
                   przes = 0;
                   }
               }

              }

            if (direction == 1)
            {

              if ( (przes < (dlug) )  )
              {
                painter->begin(Nicer);
                painter->drawImage( przes*7+7, 0,*part[ przes ] );
                painter->end();
                przes++;
              }
              else
              {
                 przes++;
                 if (przes == 4*dlug)
                 {
                   painter->begin(Nicer);
                   painter->eraseRect(QRect(0,0,Nicer->width(),Nicer->height()) );
                   painter->end();
                   direction = 2;
                   New_text();
                   przes = 0;
                   }
               }

              }

            if (direction == 2)
            {

              if ( (przes < (dlug) )  )
              {
                painter->begin(Nicer);
                painter->drawImage( przes*7+7, 0,*part[ przes ] );
                painter->end();
                przes++;
              }
              else
              {
                 przes++;
                 if (przes == 4*dlug)
                 {
                   painter->begin(Nicer);
                   painter->eraseRect(QRect(0,0,Nicer->width(),Nicer->height()) );
                   painter->end();
                   direction = 3;
                   New_text();
                   przes = 0;
                   }
               }

              }

            if (direction == 3)
            {

              if ( (przes < (dlug) )  )
              {
                painter->begin(Nicer);
                painter->drawImage( przes*7+7, 0,*part[ przes ] );
                painter->end();
                przes++;
              }
              else
              {
                 przes++;
                 if (przes == 4*dlug)
                 {
                   painter->begin(Nicer);
                   painter->eraseRect(QRect(0,0,Nicer->width(),Nicer->height()) );
                   painter->end();
                   direction = 0;
                   New_text();
                   przes = 0;
                   }
               }

              }

            }//motif

}


void KDERadio::on_mixer()
{

  if (box_ver == 0 )
    {
      KDERadio::resize( QSize(EXP_SIZE_X, EXP_SIZE_Y).expandedTo(minimumSizeHint()) );
      box_ver = 1;
      return;
    }
  if (box_ver == 1 )
    {
      KDERadio::resize( QSize(NORMAL_SIZE_X, NORMAL_SIZE_Y).expandedTo(minimumSizeHint()) );
      box_ver = 0;
      return;
    }
}


//load lower and higher frequency and setting scale
void KDERadio::set_scale()
{
   QString name_home;
   QFile *file;
   QTextStream *t;

  // setting lower and higher frequency
    name_home = home_dir();
    name_home.append("/.qtradio/settings");

    file = new QFile(name_home);
    file->open(IO_ReadOnly );
    t = new QTextStream( file );

    t->readLine();
    LOWER = (t->readLine()).toInt();
    HIGHER = (t->readLine()).toInt();
    file->close();

    printf("%i - %i \n",LOWER,HIGHER);

    //ok lower and higher set
}

// load list of stations
void KDERadio::list_load()
{
   int start_pos=0;
   QFile *file;
   QTextStream *t;
   QString name_home;
   int i;
   FILE *wej;
   char dane[150];

   name_home = home_dir();
   name_home.append("/.qtradio/programs");
   file = new QFile(name_home);
   file->open(IO_ReadOnly );
   t = new QTextStream( file );
   i=0;
   Lista->clear();
   while ( !t->atEnd() )
    {
	    Lista->insertItem( t->readLine(), -1) ;
    }
    file->close();


    name_home = home_dir();
    name_home.append("/.qtradio/start");
    file = new QFile(name_home);
    file->open(IO_ReadOnly);
    t = new QTextStream( file );
    start_pos=(t->readLine()).toInt();
    vol = (t->readLine()).toInt();
	if ( vol < 0 )
		vol = 0;
    file->close();
    //printf("%i\n",start_pos);
    //now I know the number of last station (last = previous executing of application)

    Lista->setCurrentItem(start_pos);

    name_home = home_dir();
    name_home.append("/.qtradio/programs_freq");
    strcpy(&dane[0],name_home);
    wej = fopen(&dane[0],"r");

    //printf("%i\n",i);
    i=0;
    while ( i<=start_pos)
    {
	    fscanf(wej, "%f\n",&freq);//now frequency
        i++;
    }
    fclose(wej);

    setting_leds_signal();
    setting_leds_freq();
    New_text();

    przes = 4*dlug-1;
    motif = 2;
    direction = 0;

    //set last volume

    Vol_button->move( Vol_x + ((vol)*1.0/100)*(Vol_width) ,Vol_y );


}

// show about window
void KDERadio::on_about()
{
  About *ab = new About;
  /*QLabel *l ;
  l = ab->label1;
  l->setPaletteBackgroundPixmap(*about_pix);*/

   ab->show();
}

// show info window
void KDERadio::on_info()
{
  Settings *inf = new Settings;
  QLabel *lab;
  QLineEdit *ld;
  QComboBox *comb;
  QToolButton *btn;
  QTabWidget *tb;
  QSpinBox *sp;
  QListView *lv;
  QListViewItem *item;

  int i;
  int where;
  char *devices_table[] = SOUND_DEVICE_NAMES;

  if ( ver == 1)
    data_config_device[0] = "Video4Linux";
  if ( ver == 2)
    data_config_device[0] = "Video4Linux2";
  if ( ver == 0)
    data_config_device[0] = (tr("Unknown"));

  //data_config_device[1] = give_radio_name(ver);
  data_config_device[1] = "NA";

	if (can_rds(ver) == 1) data_config_device[4] = tr("Yes");
	  else data_config_device[4] = tr("No");
  	if (can_stereo(ver) == 1) data_config_device[2] = tr("Yes");
	  else data_config_device[2] = tr("No");
  	if (can_mutable(ver) == 1) data_config_device[3] = tr("Yes");
	  else data_config_device[3] = tr("No");

  comb = inf->comboBox7;
  for (i=0;i<SOUND_MIXER_NRDEVICES;i++)
  {
   comb->insertItem(devices_table[i],-1);
   if ( devices_table[i] == data_config_device[10]) where = i;
  }

  comb->setCurrentItem(where);//combo shows actual chosen label of mixer

  comb = inf->comboBox9;
  comb->insertItem((tr("Yes")),-1);
  comb->insertItem((tr("No")),-1);
  if ( data_config_device[11] == (tr("Yes")) )
  	comb->setCurrentText((tr("Yes")));
  else comb->setCurrentText((tr("No")));

  comb = inf->comboBox8;
  comb->insertItem((tr("Yes")),-1);
  comb->insertItem((tr("No")),-1);
  if (dockable) comb->setCurrentText((tr("Yes")));
  else comb->setCurrentText((tr("No")));

  comb = inf->comboBox10;
  /*comb->insertItem((tr("1")),-1);
  comb->insertItem((tr("2")),-1);
  comb->insertItem((tr("3")),-1);
  comb->insertItem((tr("4")),-1);
  comb->insertItem((tr("5")),-1);
  comb->insertItem((tr("7")),-1);
  comb->insertItem((tr("8")),-1);*/
  if (how_strength == 1) comb->setCurrentText((tr("1")));
  if (how_strength == 2) comb->setCurrentText((tr("2")));
	if (how_strength == 3) comb->setCurrentText((tr("3")));
	if (how_strength == 4) comb->setCurrentText((tr("4")));
	if (how_strength == 5) comb->setCurrentText((tr("5")));
	if (how_strength == 6) comb->setCurrentText((tr("6")));
	if (how_strength == 7) comb->setCurrentText((tr("7")));
	if (how_strength == 8) comb->setCurrentText((tr("8")));

  ld = inf->lineEdit6;
  ld->setText( QString::number(dok,'f',2) );

  ld = inf->lineEdit4;
  ld->setText(data_config_device[9]);

  lab = inf->textLabel2;
  lab->setText(data_config_device[0]);

  lab = inf->textLabel4;
  lab->setText(data_config_device[2]);

  lab = inf->textLabel6;
  lab->setText(data_config_device[3]);

  lab = inf->textLabel8;
  lab->setText(data_config_device[4]);


  ld = inf->lineEdit3;
  ld->setText(data_config_device[6]);

  sp = inf->spinBox1;
  sp->setValue( (data_config_device[7]).toInt() );

  sp = inf->spinBox2;
  sp->setValue( (data_config_device[8]).toInt() );

  names[2] = tr("Choose Skin");
  names[12] = tr("Show Station's list");
  names[11] = tr("Settings");
  names[0] = tr("About");
  names[1] = tr("About Qt");
  names[3] = tr("Exit");
  names[9] = tr("Power");
  names[8] = tr("Next Station");
  names[10] = tr("Previous Station");
  names[5] = tr("Frequency + 0.1 MHz");
  names[4] = tr("Frequency + 0.01 MHz");
  names[7] = tr("Frequency - 0.1 MHz");
  names[6] = tr("Frequency - 0.01 MHz");
  names[14] = tr("Volume Up");
  names[13] = tr("Volume Down");

  Create_menu();//load key sequences

   lv = inf->listView2;
   for (i=0;i<=14;i++)
   {
      item = new QListViewItem(lv);
      item->setText(1, kseq[i]);
      item->setText(0,names[i]);
     }

	lv = inf->listView1;
	lv->setSorting(-1);

    QFile *file;
	QTextStream *t;
	QString nps;
    QDir d;

       	d.setFilter( QDir::Dirs );
       	d.setSorting( QDir::Name);
       	d.setPath("/usr/share/QtRadio/Skins/");
        const QFileInfoList *list = d.entryInfoList();
        QFileInfoListIterator it( *list );
        QFileInfo *fi;
	while ( (fi = it.current()) != 0 )
	{
	    nps = (fi->fileName().latin1() );
	    if ( ( nps != "/.." ) && ( nps != "/.") && !( nps =="." ) && !( nps ==".." ) )
	    {
		  item = new QListViewItem(lv);
        	item->setText(0, nps);
		  nps.prepend("/usr/share/QtRadio/Skins/");
		  item->setText(1,nps);
	    }
	    ++it;
	}

	nps = home_dir();
	nps.append("/.qtradio/Skins");
	d.setPath(nps);
	list = d.entryInfoList();
	QFileInfoListIterator it2( *list );
	while ( (fi = it2.current()) != 0 )
	{
	   nps = (fi->fileName().latin1() );
	    if ( ( nps != "/.." ) && ( nps != "/.") && !( nps =="." ) && !( nps ==".." ) )
	    {
		    item = new QListViewItem(lv);
        	item->setText(0, nps);
		    nps.prepend("/.qtradio/Skins");
		    nps.prepend(home_dir());
		    item->setText(1,nps);
	    }
	    ++it2;
	}

   btn = inf->toolButton4;

   btn = inf->toolButton5;
 

   inf->show();
   load_settings();
}

// auto-seeking stations
void KDERadio::on_seeking()
{
  //QMessageBox::information( this, "QtRadio","Seeking is not implemented yet!");
	QString name_home;
  	char dane[60];
	QString nps;
  	char path[90];
	int i;
	FILE *wyj, *wyj2;

	float tmp, tempp;
	tmp = LOWER;
	int sig1,sig2;

	name_home = home_dir();
  	name_home.append("/.qtradio/programs");
  	strcpy(&path[0], name_home);
  	wyj = fopen(&path[0],"a+");

  	name_home = home_dir();
  	name_home.append("/.qtradio/programs_freq");
  	strcpy(&path[0], name_home);
  	wyj2 = fopen(&path[0],"a+");

	load_settings();//for sure if new values appeared
	i = 0;
	do
	{
		freq = tmp;
		setting_leds_signal();
		setting_leds_freq();
		sig1 = signal_strength(ver);
		//printf("SIGNAL = %i for Freq = %.2f\n",sig1, freq);
		if ( (sig1) >= ( how_strength ) )
		{
			//printf("Checking From: Freq = %.2f, SIGNAL = %i \n", freq, sig1);
			tempp = 0;
			do
			{
				freq = tmp+tempp;
				tempp = tempp + 0.01;
				sig2 = signal_strength(ver);
				if (sig2 > sig1)
				{
					sig1 = sig2;
					//printf("Better Freq = %.2f, SIGNAL = %i \n", freq, sig1);
				}
			} while (tempp <= dok) ;
				i++;
			    nps = "Station_";
			    nps.append(QString::number(i));
				strcpy(&dane[0],nps);
				fprintf(wyj,"%s\n",&dane[0]);
			 	fprintf(wyj2,"%.2f\n",freq);
				printf("SAVING Freq = %.2f, SIGNAL = %i\n", freq, sig1, sig1/7);

		}

		tmp = tmp + dok;
	}	while (tmp <= HIGHER);

	nps = tr("I've found ");
	nps.append(QString::number(i));
	nps.append(tr(" stations\n"));
	nps.append(tr(" Click  on Switch Button"));
	QMessageBox::information( this, "QtRadio",(nps));

	fclose(wyj);
	fclose(wyj2);
}

//  record
void KDERadio::on_record()
{
  //QMessageBox::information( this, "QtRadio",(tr("Recording is not implemented yet!")));
  Recording *r =  new Recording;
  QLineEdit *l;

  QFileInfo file;

  QString s;
  int i = 0;

  s = home_dir();
  s.append("/");

  if (station_name != "")
  	s.append(station_name);
  else
    s.append("qtradio");

	s.append("_");

 	QDateTime data_time;
	data_time = data_time.currentDateTime ();
	s.append( data_time.toString ("dd.MM.yyyy_hh.mm.ss") );

  s.append(".wav");

  //if file exists add value to its end
  file.setFile(s);
  if ( file.exists() == TRUE)
  {
    do
    {
        s.insert(s.length()-4,QString::number(i));
        i++;
        printf("%i\n",i);
        file.setFile(s);
      }    while ( file.exists() == TRUE );
   }

  l = r->lineEdit1;
  l->setText(s);
  l = r->lineEdit2;
  l->setText("500");
  r->show();
}

void KDERadio::device_name_show()
{
  QString name_home;
  QFile *file;
  QTextStream *t;

   name_home = home_dir();
   name_home.append("/.qtradio/settings");
   file = new QFile(name_home);
   file->open(IO_ReadOnly);
   t = new QTextStream( file );
   strcpy( &device_name[0] , t->readLine() );
   //printf("%s\n",&device_name[0]);
   file->close();
}

void KDERadio::next_station()
{
  if ( Lista->currentItem() <= (Lista->count()-2) )
  {
    Lista->setCurrentItem(Lista->currentItem()+1);
    Combo_on();
  }
  else
  {
        Lista->setCurrentItem(0);
        Combo_on();
    }
}

void KDERadio::prev_station()
{
  if ( Lista->currentItem() != 0 )
  {
    Lista->setCurrentItem(Lista->currentItem()-1);
    Combo_on();
  }
  else
  {
        Lista->setCurrentItem(Lista->count()-1);
        Combo_on();
    }
}

void KDERadio::load_settings()
{
   QString name_home;
   QFile *file;
   QTextStream *t;
   int i;
   QString temp;
   char *devices_table[] = SOUND_DEVICE_NAMES;
   QColorGroup cg;

   name_home = home_dir();
   name_home.append("/.qtradio/settings");
   file = new QFile(name_home);
   file->open(IO_ReadOnly);
   t = new QTextStream( file );
   i=0;
   while ( !t->atEnd() && (i<=5) )
    {
	     data_config_device[i+6] =  t->readLine() ;
  	     i++;
    }
    temp = t->readLine();
    if ( temp == "DOCK=YES" ) dockable=TRUE;
    else dockable=FALSE;

    box_ver = 0;
    //box_ver sets main window in small or expanded version
    if ( data_config_device[11]  == (tr("Yes")) )
      box_ver = 1;
    if ( data_config_device[11]  == (tr("No")) )
      box_ver = 0;

	  temp = t->readLine();
	  if ( ! temp.isEmpty() )
	  	dok = temp.toFloat();

	  temp = t->readLine();
	  if ( ! temp.isEmpty() )
	  	how_strength = temp.toInt();

	  file->close();

   strcpy(&DEVICE_SND_MIX[0],data_config_device[9]);


   DEVICE_MIX = 0;//default change vol
   for (i=0;i<SOUND_MIXER_NRDEVICES;i++)
   {
    if ( devices_table[i] == data_config_device[10]) DEVICE_MIX = i;
   }


  data_config_device[0] = "???"; //give_tuner_name(ver);
  data_config_device[1] = "???"; //give_radio_name(ver);
  if (can_rds(ver) == 1) data_config_device[4] = tr("Yes");
	  else data_config_device[4] = tr("No");
  if (can_stereo(ver) == 1) data_config_device[2] = tr("Yes");
	  else data_config_device[2] = tr("No");
  if (can_mutable(ver) == 1) data_config_device[3] = tr("Yes");
	  else data_config_device[3] = tr("No");

   name_home = home_dir();
   name_home.append("/.qtradio/Skins/default");
   file = new QFile(name_home);
   file->open(IO_ReadOnly);
   t = new QTextStream( file );
   SKIN_DIR = t->readLine();
   file->close();

   Create_menu();

}

void KDERadio::new_vol_box1()
{
  vol = ( ((Vol_1_y-Vol_button_1->y() )*1.0)/(Vol_1_height)  ) *100;
  set_volume(vol, 0);

  QPixmap pix;
  int i;
      for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i))  )
      *volumer = Volume->copy((vol_size_x+2)*i+1,0,vol_size_x,vol_size_y);
      }
    for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i+48))   )
      *volumer = Volume->copy((vol_size_x+2)*i+1,nexty,vol_size_x,vol_size_y);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_1->setPixmap(pix);

	if ( DEVICE_MIX == 0 ) Vol_button->move( Vol_x + ((vol)*1.0/100)*(Vol_width) ,Vol_y );
}

void KDERadio::new_vol_box2()
{
 vol = ( ((Vol_2_y-Vol_button_2->y() )*1.0)/(Vol_2_height)  ) *100;
  set_volume(vol, 4);

   QPixmap pix;
  int i;
      for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i))  )
      *volumer = Volume->copy((vol_size_x+2)*i+1,0,vol_size_x,vol_size_y);
      }
    for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i+48))   )
      *volumer = Volume->copy((vol_size_x+2)*i+1,nexty,vol_size_x,vol_size_y);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_2->setPixmap(pix);

	if ( DEVICE_MIX == 4 ) Vol_button->move( Vol_x + ((vol)*1.0/100)*(Vol_width) ,Vol_y );
}

void KDERadio::new_vol_box3()
{
   vol = ( ((Vol_3_y-Vol_button_3->y() )*1.0)/(Vol_3_height)  ) *100;
  set_volume(vol, 5);

   QPixmap pix;
  int i;
      for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i))  )
      *volumer = Volume->copy((vol_size_x+2)*i+1,0,vol_size_x,vol_size_y);
      }
    for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i+48))   )
      *volumer = Volume->copy((vol_size_x+2)*i+1,nexty,vol_size_x,vol_size_y);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_3->setPixmap(pix);

	if ( DEVICE_MIX == 5 ) Vol_button->move( Vol_x + ((vol)*1.0/100)*(Vol_width) ,Vol_y );
}

void KDERadio::new_vol_box4()
{
   vol = ( ((Vol_4_y-Vol_button_4->y() )*1.0)/(Vol_4_height)  ) *100;
  set_volume(vol, 6);

   QPixmap pix;
  int i;
      for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i))  )
      *volumer = Volume->copy((vol_size_x+2)*i+1,0,vol_size_x,vol_size_y);
      }
    for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i+48))   )
      *volumer = Volume->copy((vol_size_x+2)*i+1,nexty,vol_size_x,vol_size_y);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_4->setPixmap(pix);

	if ( DEVICE_MIX == 6 ) Vol_button->move( Vol_x + ((vol)*1.0/100)*(Vol_width) ,Vol_y );
}

void KDERadio::new_vol_box5()
{
   vol = ( ((Vol_5_y-Vol_button_5->y() )*1.0)/(Vol_5_height)  ) *100;
  set_volume(vol, 7);

   QPixmap pix;
  int i;
      for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i))  )
      *volumer = Volume->copy((vol_size_x+2)*i+1,0,vol_size_x,vol_size_y);
      }
    for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i+48))   )
      *volumer = Volume->copy((vol_size_x+2)*i+1,nexty,vol_size_x,vol_size_y);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_5->setPixmap(pix);

	if ( DEVICE_MIX == 7 ) Vol_button->move( Vol_x + ((vol)*1.0/100)*(Vol_width) ,Vol_y );
}

void KDERadio::new_vol_box6()
{
   vol = ( ((Vol_6_y-Vol_button_6->y() )*1.0)/(Vol_6_height)  ) *100;
  set_volume(vol, 8);

   QPixmap pix;
  int i;
      for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i))  )
      *volumer = Volume->copy((vol_size_x+2)*i+1,0,vol_size_x,vol_size_y);
      }
    for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i+48))   )
      *volumer = Volume->copy((vol_size_x+2)*i+1,nexty,vol_size_x,vol_size_y);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_6->setPixmap(pix);

  if ( DEVICE_MIX == 8 ) Vol_button->move( Vol_x + ((vol)*1.0/100)*(Vol_width) ,Vol_y );
}

void KDERadio::new_vol_box7()
{
   vol = ( ((Vol_7_y-Vol_button_7->y() )*1.0)/(Vol_7_height)  ) *100;
  set_volume(vol, 22);

   QPixmap pix;
  int i;
      for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i))  )
      *volumer = Volume->copy((vol_size_x+2)*i+1,0,vol_size_x,vol_size_y);
      }
    for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i+48))   )
      *volumer = Volume->copy((vol_size_x+2)*i+1,nexty,vol_size_x,vol_size_y);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_7->setPixmap(pix);

if ( DEVICE_MIX == 22 ) Vol_button->move( Vol_x + ((vol)*1.0/100)*(Vol_width) ,Vol_y );
}

void KDERadio::new_vol_box8()
{
   vol = ( ((Vol_8_y-Vol_button_8->y() )*1.0)/(Vol_8_height)  ) *100;
  set_volume(vol, 14);

   QPixmap pix;
  int i;
      for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i))  )
      *volumer = Volume->copy((vol_size_x+2)*i+1,0,vol_size_x,vol_size_y);
      }
    for (i=0;i<=11;i++)
    {
      if ( (vol >= (4*i+48))   )
      *volumer = Volume->copy((vol_size_x+2)*i+1,nexty,vol_size_x,vol_size_y);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_8->setPixmap(pix);
  
	if ( DEVICE_MIX == 14 ) Vol_button->move( Vol_x + ((vol)*1.0/100)*(Vol_width) ,Vol_y );
}



void KDERadio::load_sound()
{
    int i;
    int tmp;
    QPixmap pix;


    Vol_button->move( Vol_x + ((get_volume(DEVICE_MIX))*1.0/100)*(Vol_width) ,Vol_y );
  //load current values of sound mixers

    Vol_button_1->move(Vol_1_x, (Vol_1_y  - ((get_volume(0))*1.0/100)*(Vol_1_height) ) );

    Vol_button_2->move(Vol_2_x, (Vol_2_y  - ((get_volume(4))*1.0/100)*(Vol_2_height) ) );
   
    Vol_button_3->move(Vol_3_x, (Vol_3_y  - ((get_volume(5))*1.0/100)*(Vol_3_height) ) );
 
    Vol_button_4->move(Vol_4_x, (Vol_4_y  - ((get_volume(6))*1.0/100)*(Vol_4_height) ) );
 
    Vol_button_5->move(Vol_5_x, (Vol_5_y  - ((get_volume(7))*1.0/100)*(Vol_5_height) ) );

    Vol_button_6->move(Vol_6_x, (Vol_6_y  - ((get_volume(8))*1.0/100)*(Vol_6_height) ) );

    Vol_button_7->move(Vol_7_x, (Vol_7_y  - ((get_volume(22))*1.0/100)*(Vol_7_height) ) );

    Vol_button_8->move(Vol_8_x, (Vol_8_y  - ((get_volume(14))*1.0/100)*(Vol_8_height) ) );  


    tmp =  get_volume(0);
    for (i=0;i<=11;i++)
    {
      if ( (tmp >= (4*i))  )
      *volumer = Volume->copy(15*i+1,0,13,88);
      }
    for (i=0;i<=11;i++)
    {
      if ( (tmp >= (4*i+48))   )
      *volumer = Volume->copy(15*i+1,92,13,88);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_1->setPixmap(pix);
    
    tmp =  get_volume(4);
        for (i=0;i<=11;i++)
    {
      if ( (tmp >= (4*i))  )
      *volumer = Volume->copy(15*i+1,0,13,88);
      }
    for (i=0;i<=11;i++)
    {
      if ( (tmp >= (4*i+48))   )
      *volumer = Volume->copy(15*i+1,92,13,88);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_2->setPixmap(pix);

    
    tmp =  get_volume(5);
    
        for (i=0;i<=11;i++)
    {
      if ( (tmp >= (4*i))  )
      *volumer = Volume->copy(15*i+1,0,13,88);
      }
    for (i=0;i<=11;i++)
    {
      if ( (tmp >= (4*i+48))   )
      *volumer = Volume->copy(15*i+1,92,13,88);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_3->setPixmap(pix);


    tmp =  get_volume(6);
       for (i=0;i<=11;i++)
    {
      if ( (tmp >= (4*i))  )
      *volumer = Volume->copy(15*i+1,0,13,88);
      }
    for (i=0;i<=11;i++)
    {
      if ( (tmp >= (4*i+48))   )
      *volumer = Volume->copy(15*i+1,92,13,88);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_4->setPixmap(pix);


    tmp =  get_volume(7);
       for (i=0;i<=11;i++)
    {
      if ( (tmp >= (4*i))  )
      *volumer = Volume->copy(15*i+1,0,13,88);
      }
    for (i=0;i<=11;i++)
    {
      if ( (tmp >= (4*i+48))   )
      *volumer = Volume->copy(15*i+1,92,13,88);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_5->setPixmap(pix);


    tmp =  get_volume(8);
        for (i=0;i<=11;i++)
    {
      if ( (tmp >= (4*i))  )
      *volumer = Volume->copy(15*i+1,0,13,88);
      }
    for (i=0;i<=11;i++)
    {
      if ( (tmp >= (4*i+48))   )
      *volumer = Volume->copy(15*i+1,92,13,88);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_6->setPixmap(pix);


    tmp =  get_volume(22);
      for (i=0;i<=11;i++)
    {
      if ( (tmp >= (4*i))  )
      *volumer = Volume->copy(15*i+1,0,13,88);
      }
    for (i=0;i<=11;i++)
    {
      if ( (tmp >= (4*i+48))   )
      *volumer = Volume->copy(15*i+1,92,13,88);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_7->setPixmap(pix);


    tmp =  get_volume(14);
        for (i=0;i<=11;i++)
    {
      if ( (tmp >= (4*i))  )
      *volumer = Volume->copy(15*i+1,0,13,88);
      }
    for (i=0;i<=11;i++)
    {
      if ( (tmp >= (4*i+48))   )
      *volumer = Volume->copy(15*i+1,92,13,88);
      }
    pix.convertFromImage(*volumer);
    Vol_bar_8->setPixmap(pix);
  
}

//THIS FUNCTION READ SKIN CONFIG FILE 
void KDERadio::load_skin()
{
    QString name_home;
    QFile *file;
    QTextStream *t;
    QFont font;
    QString temp1,temp2,temp3,temp4;
    QString name,temp;
    QColor color1,color2;


   name = SKIN_DIR; //skin's dir form config file
   temp4 = name;
   temp4.append("/settings");
   file = new QFile(temp4);
   file->open(IO_ReadOnly);
   if ( ! file->exists() || ! file->isReadable())
   {
   	QMessageBox::information( this, "QtRadio",(tr("Can't open skin file - see README in your sources")));
	KDERadio::close();
   	return;
   }

   name_home= name;
   name_home.append("/settings");

   file = new QFile(name_home);
   file->open(IO_ReadOnly);
   t = new QTextStream( file );
   
   temp1 = t->readLine();
   temp1.remove(0,21);
   temp2 = t->readLine();
   temp2.remove(0,21);
   
   temp4 = name;
   temp4.append("/");
   temp = t->readLine();
   temp.remove(0,9);
   temp4.append(temp);
   if ( box_ver == 0 ) KDERadio::resize( QSize(temp1.toInt(), temp2.toInt() ).expandedTo(minimumSizeHint()) );
   NORMAL_SIZE_X = temp1.toInt();
   NORMAL_SIZE_Y = temp2.toInt();
   if (temp4 != "") KDERadio::setPaletteBackgroundPixmap(QPixmap(temp4));
   t->readLine();
   
   temp3 = t->readLine();
   temp3.remove(0,20);
   temp4 = t->readLine();
   temp4.remove(0,20);
   if ( box_ver == 1 ) KDERadio::resize( QSize(temp3.toInt(), temp4.toInt() ).expandedTo(minimumSizeHint()) );
   EXP_SIZE_X = temp3.toInt();
   EXP_SIZE_Y = temp4.toInt();
   t->readLine();
   
   temp1 = t->readLine();
   temp1.remove(0,21);
   temp2 = t->readLine();
   temp2.remove(0,21);
   temp3 = t->readLine();
   temp3.remove(0,22);
   temp4 = t->readLine();
   temp4.remove(0,22);
   Close_button->setGeometry(QRect(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt()));
   t->readLine();
   
   temp1 = t->readLine();
   temp1.remove(0,19);
   temp2 = t->readLine();
   temp2.remove(0,19);
   temp3 = t->readLine();
   temp3.remove(0,20);
   temp4 = t->readLine();
   temp4.remove(0,20);
   Min_button->setGeometry(QRect(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt()));
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,20);
   temp2 = t->readLine();
   temp2.remove(0,20);
   temp3 = t->readLine();
   temp3.remove(0,21);
   temp4 = t->readLine();
   temp4.remove(0,21);
   Move_button->setGeometry(QRect(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt()));
   t->readLine();

       
   temp1 = t->readLine();
   temp1.remove(0,20);
   temp2 = t->readLine();
   temp2.remove(0,20);
   temp3 = t->readLine();
   temp3.remove(0,21);
   temp4 = t->readLine();
   temp4.remove(0,21);
   Freq_width =  temp3.toInt();
   Freq_height = temp4.toInt();
   Freq_x = temp1.toInt();
   Freq_y = temp2.toInt();
   Freq_button->setGeometry(Freq_x, Freq_y, 11, 11 );
   Freq_button->setBackgroundOrigin(ParentOrigin);
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,19);
   temp2 = t->readLine();
   temp2.remove(0,19);
   temp3 = t->readLine();
   temp3.remove(0,20);
   temp4 = t->readLine();
   temp4.remove(0,20);
   Vol_width =  temp3.toInt();
   Vol_height = temp4.toInt();
   Vol_x = temp1.toInt();
   Vol_y = temp2.toInt();
   Vol_button->setGeometry(Vol_x, Vol_y, 11, 11 );
   Vol_button->setBackgroundOrigin(ParentOrigin);
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,23);
   temp2 = t->readLine();
   temp2.remove(0,23);
   temp3 = t->readLine();
   temp3.remove(0,24);
   temp4 = t->readLine();
   temp4.remove(0,24);
   One->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   One->setBackgroundOrigin(ParentOrigin);
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,24);
   temp2 = t->readLine();
   temp2.remove(0,24);
   temp3 = t->readLine();
   temp3.remove(0,25);
   temp4 = t->readLine();
   temp4.remove(0,25);
   Two->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());	
   Two->setBackgroundOrigin(ParentOrigin);
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,23);
   temp2 = t->readLine();
   temp2.remove(0,23);
   temp3 = t->readLine();
   temp3.remove(0,24);
   temp4 = t->readLine();
   temp4.remove(0,24);
   Three->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   Three->setBackgroundOrigin(ParentOrigin);
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,23);
   temp2 = t->readLine();
   temp2.remove(0,23);
   temp3 = t->readLine();
   temp3.remove(0,24);
   temp4 = t->readLine();
   temp4.remove(0,24);
   Four->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   Four->setBackgroundOrigin(ParentOrigin);
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,24);
   temp2 = t->readLine();
   temp2.remove(0,24);
   temp3 = t->readLine();
   temp3.remove(0,25);
   temp4 = t->readLine();
   temp4.remove(0,25);
   Five->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());               
   Five->setBackgroundOrigin(ParentOrigin);
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,17);
   temp2 = t->readLine();
   temp2.remove(0,17);
   temp3 = t->readLine();
   temp3.remove(0,18);
   temp4 = t->readLine();
   temp4.remove(0,18);
   Nicer->setGeometry(0,0,temp3.toInt()*2,temp4.toInt() );
   frame->setGeometry(QRect(temp1.toInt()-1,temp2.toInt()-1,temp3.toInt()+2,temp4.toInt()+2));
   temp2 = t->readLine();
   temp2.remove(0,19);
   color2.setNamedColor(temp2);
   Nicer->setPaletteBackgroundColor(color2);
   frame->setPaletteBackgroundColor(color2);
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,19);
   temp2 = t->readLine();
   temp2.remove(0,19);
   temp3 = t->readLine();
   temp3.remove(0,20);
   temp4 = t->readLine();
   temp4.remove(0,20);
   Signal->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   Signal->setBackgroundOrigin(ParentOrigin);
   temp2 = t->readLine();
   temp2.remove(0,19);
   color2.setNamedColor(temp2);
   Signal->setPaletteBackgroundColor(color2);
   t->readLine();


   temp1 = t->readLine();
   temp1.remove(0,18);
   temp2 = t->readLine();
   temp2.remove(0,18);
   temp3 = t->readLine();
   temp3.remove(0,19);
   temp4 = t->readLine();
   temp4.remove(0,19);
   Power->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   Power->setBackgroundOrigin(ParentOrigin);           
   temp2 = t->readLine();
   temp2.remove(0,19);
   color2.setNamedColor(temp2);
   Power->setBackgroundOrigin(ParentOrigin);
   Power->setPaletteBackgroundColor(color2);	   
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,19);
   temp2 = t->readLine();
   temp2.remove(0,19);
   temp3 = t->readLine();
   temp3.remove(0,20);
   temp4 = t->readLine();
   temp4.remove(0,20);
   Stereo->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   Stereo->setBackgroundOrigin(ParentOrigin);          
   temp2 = t->readLine();
   temp2.remove(0,19);
   color2.setNamedColor(temp2);
   Stereo->setBackgroundOrigin(ParentOrigin);
   Stereo->setPaletteBackgroundColor(color2);	   
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,28);
   temp2 = t->readLine();
   temp2.remove(0,28);
   temp3 = t->readLine();
   temp3.remove(0,29);
   temp4 = t->readLine();
   temp4.remove(0,29);
   Next_button->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,28);
   temp2 = t->readLine();
   temp2.remove(0,28);
   temp3 = t->readLine();
   temp3.remove(0,29);
   temp4 = t->readLine();
   temp4.remove(0,29);
   Previous_button->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,29);
   temp2 = t->readLine();
   temp2.remove(0,29);
   temp3 = t->readLine();
   temp3.remove(0,30);
   temp4 = t->readLine();
   temp4.remove(0,30);
   Forward_long->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,30);
   temp2 = t->readLine();
   temp2.remove(0,30);
   temp3 = t->readLine();
   temp3.remove(0,31);
   temp4 = t->readLine();
   temp4.remove(0,31);
   Forward_short->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,29);
   temp2 = t->readLine();
   temp2.remove(0,29);
   temp3 = t->readLine();
   temp3.remove(0,30);
   temp4 = t->readLine();
   temp4.remove(0,30);
   Reward_long->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,30);
   temp2 = t->readLine();
   temp2.remove(0,30);
   temp3 = t->readLine();
   temp3.remove(0,31);
   temp4 = t->readLine();
   temp4.remove(0,31);
   Reward_short->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,20);
   temp2 = t->readLine();
   temp2.remove(0,20);
   temp3 = t->readLine();
   temp3.remove(0,21);
   temp4 = t->readLine();
   temp4.remove(0,21);
   Seek_button->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,19);
   temp2 = t->readLine();
   temp2.remove(0,19);
   temp3 = t->readLine();
   temp3.remove(0,20);
   temp4 = t->readLine();
   temp4.remove(0,20);
   Rec_button->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   t->readLine();
  
   temp1 = t->readLine();
   temp1.remove(0,21);
   temp2 = t->readLine();
   temp2.remove(0,21);
   temp3 = t->readLine();
   temp3.remove(0,22);
   temp4 = t->readLine();
   temp4.remove(0,22);
   Mixer_button->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,24);
   temp2 = t->readLine();
   temp2.remove(0,24);
   temp3 = t->readLine();
   temp3.remove(0,25);
   temp4 = t->readLine();
   temp4.remove(0,25);
   Options_button->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   t->readLine();
 

   temp1 = t->readLine();
   temp1.remove(0,27);
   temp2 = t->readLine();
   temp2.remove(0,27);
   temp3 = t->readLine();
   temp3.remove(0,28);
   temp4 = t->readLine();
   temp4.remove(0,28);
   Saver_button->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,20);
   temp2 = t->readLine();
   temp2.remove(0,20);
   temp3 = t->readLine();
   temp3.remove(0,21);
   temp4 = t->readLine();
   temp4.remove(0,21);
   Sound_mute->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,21);
   temp2 = t->readLine();
   temp2.remove(0,21);
   temp3 = t->readLine();
   temp3.remove(0,22);
   temp4 = t->readLine();
   temp4.remove(0,22);
   Switch_button->setGeometry(temp1.toInt(),temp2.toInt(),temp3.toInt(),temp4.toInt());
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,21);
   temp2 = t->readLine();
   temp2.remove(0,21);
   temp3 = t->readLine();
   temp3.remove(0,22);
   temp4 = t->readLine();
   temp4.remove(0,22);
   Vol_bar_1->setGeometry(temp1.toInt(),temp2.toInt()-temp4.toInt(),temp3.toInt(),temp4.toInt());
   Vol_1_height = temp4.toInt()-15;
   Vol_1_x = temp1.toInt()+1;
   Vol_1_y = temp2.toInt()-12;
   Vol_button_1->setGeometry(Vol_1_x, Vol_1_y, 10, 10 );
   Vol_bar_1->setBackgroundOrigin(ParentOrigin);
   Vol_button_1->setBackgroundOrigin(ParentOrigin);
   t->readLine();
   
   temp1 = t->readLine();
   temp1.remove(0,21);
   temp2 = t->readLine();
   temp2.remove(0,21);
   temp3 = t->readLine();
   temp3.remove(0,22);
   temp4 = t->readLine();
   temp4.remove(0,22);
   Vol_bar_2->setGeometry(temp1.toInt(),temp2.toInt()-temp4.toInt(),temp3.toInt(),temp4.toInt());
   Vol_2_height = temp4.toInt()-15;
   Vol_2_x = temp1.toInt()+1;
   Vol_2_y = temp2.toInt()-12;
   Vol_button_2->setGeometry(Vol_2_x, Vol_2_y, 10, 10 );
   Vol_bar_2->setBackgroundOrigin(ParentOrigin);
   Vol_button_2->setBackgroundOrigin(ParentOrigin);
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,21);
   temp2 = t->readLine();
   temp2.remove(0,21);
   temp3 = t->readLine();
   temp3.remove(0,22);
   temp4 = t->readLine();
   temp4.remove(0,22);
   Vol_bar_3->setGeometry(temp1.toInt(),temp2.toInt()-temp4.toInt(),temp3.toInt(),temp4.toInt());
   Vol_3_height = temp4.toInt()-15;
   Vol_3_x = temp1.toInt()+1;
   Vol_3_y = temp2.toInt()-12;
   Vol_button_3->setGeometry(Vol_3_x, Vol_3_y, 10, 10 );
   Vol_bar_3->setBackgroundOrigin(ParentOrigin);
   Vol_button_3->setBackgroundOrigin(ParentOrigin);
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,21);
   temp2 = t->readLine();
   temp2.remove(0,21);
   temp3 = t->readLine();
   temp3.remove(0,22);
   temp4 = t->readLine();
   temp4.remove(0,22);
   Vol_bar_4->setGeometry(temp1.toInt(),temp2.toInt()-temp4.toInt(),temp3.toInt(),temp4.toInt());
   Vol_4_height = temp4.toInt()-15;
   Vol_4_x = temp1.toInt()+1;
   Vol_4_y = temp2.toInt()-12;
   Vol_button_4->setGeometry(Vol_4_x, Vol_4_y, 10, 10 );
   Vol_bar_4->setBackgroundOrigin(ParentOrigin);
   Vol_button_4->setBackgroundOrigin(ParentOrigin);
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,21);
   temp2 = t->readLine();
   temp2.remove(0,21);
   temp3 = t->readLine();
   temp3.remove(0,22);
   temp4 = t->readLine();
   temp4.remove(0,22);
   Vol_bar_5->setGeometry(temp1.toInt(),temp2.toInt()-temp4.toInt(),temp3.toInt(),temp4.toInt());
   Vol_5_height = temp4.toInt()-15;
   Vol_5_x = temp1.toInt()+1;
   Vol_5_y = temp2.toInt()-12;
   Vol_button_5->setGeometry(Vol_5_x, Vol_5_y, 10, 10 );
   Vol_bar_5->setBackgroundOrigin(ParentOrigin);
   Vol_button_5->setBackgroundOrigin(ParentOrigin);
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,21);
   temp2 = t->readLine();
   temp2.remove(0,21);
   temp3 = t->readLine();
   temp3.remove(0,22);
   temp4 = t->readLine();
   temp4.remove(0,22);
   Vol_bar_6->setGeometry(temp1.toInt(),temp2.toInt()-temp4.toInt(),temp3.toInt(),temp4.toInt());
   Vol_6_height = temp4.toInt()-15;
   Vol_6_x = temp1.toInt()+1;
   Vol_6_y = temp2.toInt()-12;
   Vol_button_6->setGeometry(Vol_6_x, Vol_6_y, 10, 10 );
   Vol_bar_6->setBackgroundOrigin(ParentOrigin);
   Vol_button_6->setBackgroundOrigin(ParentOrigin);
   t->readLine();

   temp1 = t->readLine();
   temp1.remove(0,21);
   temp2 = t->readLine();
   temp2.remove(0,21);
   temp3 = t->readLine();
   temp3.remove(0,22);
   temp4 = t->readLine();
   temp4.remove(0,22);
   Vol_bar_7->setGeometry(temp1.toInt(),temp2.toInt()-temp4.toInt(),temp3.toInt(),temp4.toInt());
   Vol_7_height = temp4.toInt()-15;
   Vol_7_x = temp1.toInt()+1;
   Vol_7_y = temp2.toInt()-12;
   Vol_button_7->setGeometry(Vol_7_x, Vol_7_y, 10, 10 );
   Vol_bar_7->setBackgroundOrigin(ParentOrigin);
   Vol_button_7->setBackgroundOrigin(ParentOrigin);
   t->readLine();


   temp1 = t->readLine();
   temp1.remove(0,21);
   temp2 = t->readLine();
   temp2.remove(0,21);
   temp3 = t->readLine();
   temp3.remove(0,22);
   temp4 = t->readLine();
   temp4.remove(0,22);
   Vol_bar_8->setGeometry(temp1.toInt(),temp2.toInt()-temp4.toInt(),temp3.toInt(),temp4.toInt());
   Vol_8_height = temp4.toInt()-15;
   Vol_8_x = temp1.toInt()+1;
   Vol_8_y = temp2.toInt()-12;
   Vol_button_8->setGeometry(Vol_8_x, Vol_8_y, 10, 10 );
   Vol_bar_8->setBackgroundOrigin(ParentOrigin);
   Vol_button_8->setBackgroundOrigin(ParentOrigin);
   t->readLine();

   temp4 = name;
   temp4.append("/");
   temp = t->readLine();
   temp.remove(0,16);
   temp4.append(temp);
   Volume = new QImage(temp4); 
   temp = t->readLine();
   temp4 = temp;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   vol_size_x = temp4.toInt();

   temp4 = temp;
   temp4.remove(0,temp4.find(",")+1);
   temp = temp4;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   vol_size_y = temp4.toInt();

   temp4 = temp;
   temp4.remove(0,temp4.find(",")+1);
   temp = temp4;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   nexty = temp4.toInt();

   temp4 = temp;
   temp4.remove(0,temp4.find(",")+1);
   temp = temp4;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   int  xpos = temp4.toInt();

   temp4 = temp;
   temp4.remove(0,temp4.find(",")+1);
   temp = temp4;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   int ypos = temp4.toInt();

   temp4 = temp;
   temp4.remove(0,temp4.find(",")+1);
   temp = temp4;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   int sx = temp4.toInt();

   temp4 = temp;
   temp4.remove(0,temp4.find(",")+1);
   temp = temp4;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   int sy = temp4.toInt();

   //printf("%i %i %i %i %i %i %i\n",sizex,sizey,nexty,xpos,ypos,sx,sy);
   
   t->readLine();
      
   QPixmap pix;
   pix.convertFromImage(Volume->copy(xpos,ypos,sx,sy));
   Vol_button_1->setPixmap(pix);
   Vol_button_2->setPixmap(pix);
   Vol_button_3->setPixmap(pix);
   Vol_button_4->setPixmap(pix);
   Vol_button_5->setPixmap(pix);
   Vol_button_6->setPixmap(pix);
   Vol_button_7->setPixmap(pix);
   Vol_button_8->setPixmap(pix);

    pix.convertFromImage(Volume->copy(0,0,vol_size_x,vol_size_y));
    Vol_bar_1->setPixmap(pix);
    Vol_bar_2->setPixmap(pix);
    Vol_bar_3->setPixmap(pix);
    Vol_bar_4->setPixmap(pix);
    Vol_bar_5->setPixmap(pix);
    Vol_bar_6->setPixmap(pix);
    Vol_bar_7->setPixmap(pix);
    Vol_bar_8->setPixmap(pix);

   temp4 = name;
   temp4.append("/");
   temp = t->readLine();
   temp.remove(0,24);
   temp4.append(temp);
   if (temp4 != "") Frequency = new QImage(temp4);

   temp = t->readLine();
   temp4 = temp;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   int x1 = temp4.toInt();

   temp4 = temp;
   temp4.remove(0,temp4.find(",")+1);
   temp = temp4;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   int y1 = temp4.toInt();

   temp4 = temp;
   temp4.remove(0,temp4.find(",")+1);
   temp = temp4;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   int x2 = temp4.toInt();

   temp4 = temp;
   temp4.remove(0,temp4.find(",")+1);
   temp = temp4;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   int  y2 = temp4.toInt();
   
   t->readLine();
       
   pix.convertFromImage(Frequency->copy(0,0,x1,y1));
   Freq_button->setPixmap(pix);
   pix.convertFromImage(Frequency->copy(x1+1,0,x2,y2));
   Vol_button->setPixmap(pix);     

   //numbers
   temp4 = name;
   temp4.append("/");
   temp = t->readLine();
   temp.remove(0,16);
   temp4.append(temp);
   if (temp4 != "") Number = new QImage(temp4);

   temp = t->readLine();
   temp4 = temp;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   int w = temp4.toInt();

   temp4 = temp;
   temp4.remove(0,temp4.find(",")+1);
   temp = temp4;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   int h = temp4.toInt();
   
   t->readLine();

   num_0->convertFromImage(Number->copy(0,0,w,h));
  
   num_1->convertFromImage(Number->copy( (w+1),0,w,h));
   
   num_2->convertFromImage(Number->copy((w+1)*2,0,w,h));
   
   num_3->convertFromImage(Number->copy((w+1)*3,0,w,h));
   
   num_4->convertFromImage(Number->copy((w+1)*4,0,w,h));

   num_5->convertFromImage(Number->copy((w+1)*5,0,w,h));

   num_6->convertFromImage(Number->copy((w+1)*6,0,w,h));
;
   num_7->convertFromImage(Number->copy((w+1)*7,0,w,h));

   num_8->convertFromImage(Number->copy((w+1)*8,0,w,h));

   num_9->convertFromImage(Number->copy((w+1)*9,0,w,h));
   
   //led's buttons
   temp4 = name;
   temp4.append("/");
   temp = t->readLine();
   temp.remove(0,13);
   temp4.append(temp);
   if (temp4 != "") Led = new QImage(temp4);

   temp = t->readLine();
   temp4 = temp;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   int xx1 = temp4.toInt();

   temp4 = temp;
   temp4.remove(0,temp4.find(",")+1);
   temp = temp4;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   int yy1 = temp4.toInt();

   temp4 = temp;
   temp4.remove(0,temp4.find(",")+1);
   temp = temp4;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   int xx2 = temp4.toInt();

   temp4 = temp;
   temp4.remove(0,temp4.find(",")+1);
   temp = temp4;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   int  yy2 = temp4.toInt();
   
   t->readLine();

   power_on->convertFromImage(Led->copy(xx1*2+4,0,xx2,yy2));

   power_off->convertFromImage(Led->copy(xx1*2+6+xx2,0,xx2,yy2));

   stereo_on->convertFromImage(Led->copy(0,0,xx1,yy1));

   stereo_off->convertFromImage(Led->copy(xx1+2,0,xx1,yy1));
  
    //signal's strength
   temp4 = name;
   temp4.append("/");
   temp = t->readLine();
   temp.remove(0,16);
   temp4.append(temp);
   if (temp4 != "") Signal_Led = new QImage(temp4);

   temp = t->readLine();
   temp4 = temp;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   int w1 = temp4.toInt();

   temp4 = temp;
   temp4.remove(0,temp4.find(",")+1);
   temp = temp4;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   int h1 = temp4.toInt();
   
   t->readLine();

   signal_8->convertFromImage(Signal_Led->copy(0,0,w1,h1));

   signal_7->convertFromImage(Signal_Led->copy(0,(h1+1),w1,h1));

   signal_6->convertFromImage(Signal_Led->copy(0,(h1+1)*2,w1,h1));

   signal_5->convertFromImage(Signal_Led->copy(0,(h1+1)*3,w1,h1));

   signal_4->convertFromImage(Signal_Led->copy(0,(h1+1)*4,w1,h1));

   signal_3->convertFromImage(Signal_Led->copy(0,(h1+1)*5,w1,h1));

   signal_2->convertFromImage(Signal_Led->copy(0,(h1+1)*6,w1,h1));

   signal_1->convertFromImage(Signal_Led->copy(0,(h1+1)*7,w1,h1));

   signal_0->convertFromImage(Signal_Led->copy(0,(h1+1)*8,w1,h1));
   //text
   temp4 = name;
   temp4.append("/");
   temp = t->readLine();
   temp.remove(0,14);
   temp4.append(temp);
   text = new QImage(temp4);
   t->readLine();
   
   int i = 0;
   for (i=0;i<=199;i++)
    part[i] = new QImage(4,6,8);

    //main buttons
   temp4 = name;
   temp4.append("/");
   temp = t->readLine();
   temp.remove(0,21);
   temp4.append(temp);
   Main_button = new QImage(temp4);

   temp = t->readLine();
   temp4 = temp;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   w1 = temp4.toInt();

   temp4 = temp;
   temp4.remove(0,temp4.find(",")+1);
   temp = temp4;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   h1 = temp4.toInt();
   
   t->readLine();

   pix.convertFromImage(Main_button->copy(0,0,w1,h1));
   Reward_long->setPixmap(pix);
   pix.convertFromImage(Main_button->copy( (w1+1),0,w1,h1));
   Reward_short->setPixmap(pix);
   pix.convertFromImage(Main_button->copy((w1+1)*2,0,w1,h1));
   Forward_short->setPixmap(pix);
   pix.convertFromImage(Main_button->copy((w1+1)*3,0,w1,h1));
   Forward_long->setPixmap(pix);
   pix.convertFromImage(Main_button->copy((w1+1)*4,0,w1,h1));
   Seek_button->setPixmap(pix);
   pix.convertFromImage(Main_button->copy((w1+1)*5,0,w1,h1));
   Sound_mute->setPixmap(pix);
   pix.convertFromImage(Main_button->copy((w1+1)*6,0,w1,h1));
   Rec_button->setPixmap(pix);
   pix.convertFromImage(Main_button->copy((w1+1)*7,0,w1,h1));
   Options_button->setPixmap(pix);
   pix.convertFromImage(Main_button->copy((w1+1)*8,0,w1,h1));
   Switch_button->setPixmap(pix);
   pix.convertFromImage(Main_button->copy((w1+1)*9,0,w1,h1));
   Mixer_button->setPixmap(pix);
   pix.convertFromImage(Main_button->copy((w1+1)*10,0,w1,h1));
   Previous_button->setPixmap(pix);
   pix.convertFromImage(Main_button->copy((w1+1)*11,0,w1,h1));
   Next_button->setPixmap(pix);
   pix.convertFromImage(Main_button->copy((w1+1)*12,0,w1,h1));
   Saver_button->setPixmap(pix);  

   //window buttons
   temp4 = name;
   temp4.append("/");
   temp = t->readLine();
   temp.remove(0,23);
   temp4.append(temp);
   Window_button = new QImage(temp4);

   temp = t->readLine();
   temp4 = temp;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   w1 = temp4.toInt();

   temp4 = temp;
   temp4.remove(0,temp4.find(",")+1);
   temp = temp4;
   temp4.remove(temp4.find(","),temp4.length()-temp4.find(","));
   h1 = temp4.toInt();
   
   t->readLine();

   pix.convertFromImage(Window_button->copy(0,0,w1,h1));
   Move_button->setPixmap(pix);
    pix.convertFromImage(Window_button->copy(w1+1,0,w1,h1));
   Min_button->setPixmap(pix);
    pix.convertFromImage(Window_button->copy(2*w1+2,0,w1,h1));
   Close_button->setPixmap(pix);

   //pixmap for about window
   temp4 = name;
   temp4.append("/");
   temp = t->readLine();
   temp.remove(0,15);
   temp4.append(temp);
   about_pix = new QPixmap(temp4);   

   volumer = new QImage(14,63,8);
   
   file->close();
   
   Power->setPixmap(*power_off);
   Stereo->setPixmap(*stereo_off);
   Signal->setPixmap(*signal_0);
   One->setPixmap(*num_0);
   Two->setPixmap(*num_8);
   Three->setPixmap(*num_8);
   Four->setPixmap(*num_0);
   Five->setPixmap(*num_0);
   
}


void KDERadio::aboutQt()
{
    QMessageBox::aboutQt( this, (tr("About Qt")) );
}

void KDERadio::Create_menu()
{
 //read key shortcuts//
    QFile *file;

    QString s;
    s = home_dir();
    s.append("/.qtradio/keys");

    file = new QFile(s);
    if ( file->open(IO_ReadOnly) )
    {
    QTextStream *t;
    t = new QTextStream( file );

    int i;

    for (i=0;i<=14;i++)
    {
        kseq[i] = t->readLine();
      }

      file->close();
     }
     //now we can use these shortcuts

    style->clear();
    style_dock->clear();

    style->insertItem(tr("Skins"),this,SLOT(Show_skin()), QKeySequence(kseq[2]));
    style->insertItem( tr("List"), this, SLOT(Save()), QKeySequence(kseq[12]));
    style->insertItem( tr("Settings"), this, SLOT(on_info()), QKeySequence(kseq[11]));
    style->insertItem( tr("About"), this, SLOT(on_about()), QKeySequence(kseq[0]));
    style->insertItem( tr("About Qt"), this, SLOT(aboutQt()), QKeySequence(kseq[1]));
    style->insertSeparator();
    style->insertItem(tr("Exit QtRadio"), this, SLOT( on_exit() ), QKeySequence(kseq[3]) );
    style->setStyle(tr("Default"));

	style_dock->insertItem( tr("Power On/Off"), this, SLOT(Power_S()), QKeySequence(kseq[9]) );
	style_dock->insertItem( tr("Next Station"), this, SLOT(next_station()),QKeySequence(kseq[8]));
	style_dock->insertItem( tr("Previous Station"), this, SLOT(prev_station()),QKeySequence(kseq[10]) );
	style_dock->insertItem( tr("Freq +0.1"), this, SLOT(on_Forward()),QKeySequence(kseq[5]) );
	style_dock->insertItem( tr("Freq +0.01"), this, SLOT(short_Forward()),QKeySequence(kseq[4]) );
	style_dock->insertItem( tr("Freq -0.1"), this, SLOT(on_reward()),QKeySequence(kseq[7]) );
	style_dock->insertItem( tr("Freq -0.01"), this, SLOT(short_reward()),QKeySequence(kseq[6]) );
    style_dock->insertItem( tr("Vol +"), this, SLOT(Volume_up()),QKeySequence(kseq[14]) );
	style_dock->insertItem( tr("Vol -"), this, SLOT(Volume_down()),QKeySequence(kseq[13]));
    style_dock->insertSeparator();
    style_dock->insertItem( tr("About Qt"), this, SLOT(aboutQt()) );
    style_dock->insertSeparator();
    style_dock->insertItem( tr("Exit QtRadio"), this, SLOT( on_exit() ) );
    style_dock->setStyle( tr("Default") );
  }



void KDERadio::execute_lirc_command (char *cmd)
{
    #ifdef HAVE_LIRC
	if (strcasecmp (cmd, "freq up") == 0)
	{
		short_Forward();
	}
	else if (strcasecmp (cmd, "freq down") == 0)
	{
		short_reward();
	}
	else if (strcasecmp (cmd, "volume up") == 0)
	{
		Volume_up();
	}
	else if (strcasecmp (cmd, "volume down") == 0)
	{
		Volume_down();
	}
	else if (strcasecmp (cmd, "mute") == 0)
	{
		mute_pressed();
	}
	else if (strcasecmp (cmd, "tv") == 0)
	{
		;
	}
	else if (strcasecmp (cmd, "quit") == 0)
	{
		on_exit();
	}
	else if (strcasecmp (cmd, "channel up") == 0)
	{
		next_station();
	}
	else if (strcasecmp (cmd, "channel down") == 0)
	{
		prev_station();
	}
	else if (strcasecmp (cmd, "seeking") == 0)
	{
		on_seeking();
	}
	else if (strcasecmp (cmd, "mixer") == 0)
	{
		on_mixer();
	}
	else if (strcasecmp (cmd, "record") == 0)
	{
		on_record();
	}
  else if (strcasecmp (cmd, "power") == 0)
	{
		Switcher();
	}
  else if (strcasecmp (cmd, "mouse mode") == 0)
	{
		/*
      is it useful???
      if ( sockfd == 1) lirc_deinit();
      else
        initialize_lirc();   */
	}
	else
	{
    		printf ("Ukknown lirc command: %s\n", cmd);
	}
  #endif
}

int KDERadio::initialize_lirc()
{
   #ifdef HAVE_LIRC
	printf("Initializing LIRC\n");
	if ((lirc_fd = lirc_init ("QtRadio", 0)) <=0)
	{
		perror("lirc_init");
		return 0;
	}

	if (lirc_readconfig (NULL, &config, NULL) != 0)
	{
		perror("lirc_readconfig");
    		lirc_deinit ();
    		lirc_fd = -1;
    		return 0;
	}

	fcntl (lirc_fd, F_SETFL, O_NONBLOCK);
	fcntl (lirc_fd, F_SETFD, FD_CLOEXEC);
  printf("SUCCESS\n");
  //sockfd = 1;
	return 1;
  #endif
}

void KDERadio::deinitialize_lirc()
{
   #ifdef HAVE_LIRC
	if (lirc_fd <= 0)
		return;

    printf("Shutting down lirc\n");
    //sn->setEnabled(FALSE);
  TimerL->stop();
  //sockfd = 0;
	lirc_freeconfig(config);
	lirc_deinit ();
  #endif
}

void KDERadio::dataReceived()
{
   #ifdef HAVE_LIRC
	char *code, *cmd;
	int ret ;
    printf("KRY\n");
    while (lirc_nextcode (&code) == 0 )
    {
    if (code==NULL) return;
    if ( ret=lirc_code2char (config, code, &cmd) == 0 && cmd != NULL)
    {
          printf("lirc command: %s\n", cmd);
			execute_lirc_command(cmd);
      }
       else
               {
                /*
                it works...I know it doesn't look good...
                printf("Lirc error occured\n");
		        sn->setEnabled(FALSE);
		        lirc_freeconfig (config);
		        config = NULL;
		        lirc_deinit ();   
                 }              */

                 free (code);
                 }
      } 

  
  /*previous unstable:
  while (lirc_nextcode (&code) == 0 )
	{
    if (code==NULL) continue;

  while (ret=lirc_code2char (config, code, &cmd) == 0 && cmd != NULL)
		{
			printf("lirc command: %s\n", cmd);
			execute_lirc_command(cmd);
    }

  free (code);
  //if (ret ==-1) break;
	}

	// on LIRC error, shutdown added input
	if (ret == -1)
	{
		printf("Lirc error occured\n");
		//sn->setEnabled(FALSE);
		lirc_freeconfig (config);
		config = NULL;
		lirc_deinit ();
	}     */
  #endif
}

void KDERadio::start_lirc()
{
   #ifdef HAVE_LIRC
	if (lirc_fd<0)
    {
          printf("Lirc not initialized\n");
	       return;
    }

  TimerL = new QTimer( this);
  connect( TimerL, SIGNAL(timeout()),this, SLOT(dataReceived()) );
  TimerL->start(1);
              
  /*sn = new QSocketNotifier( sockfd, QSocketNotifier::Write, this );
  connect( sn, SIGNAL(activated(int)),this, SLOT(dataReceived()) );
  sn->setEnabled(TRUE);  */
  #endif

}

