/***************************************************************************
                          qtradio.h  -  description
                             -------------------
    begin                : Sat Apr 12 00:32:39 CEST 2003
    copyright            : (C) 2003 by Pawel Pustelnik
    email                : pawelpus@o2.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QTRADIO_H
#define QTRADIO_H

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif

// include files for QT
#include <qapp.h>
#include <qmainwindow.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qstatusbar.h>
#include <qwhatsthis.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qmsgbox.h>
#include <qfiledialog.h>
#include <qprinter.h>
#include <qpainter.h>
#include <qwidget.h>
#include <qvariant.h>
#include <qstring.h>
#include <qdialog.h>
#include <qmessagebox.h>
#include <qtextstream.h>
#include <qfile.h>


// application specific includes
#include "info.h"
#include "add.h"
#include "about.h"
#include "skin.h"
#include "recording.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class KLed;
class QComboBox;
class QFrame;
class QLCDNumber;
class QLineEdit;
class QToolButton;
class QFrame;
class QButtonGroup;

class KDERadio : public QWidget
{
  Q_OBJECT
  public:
    /** construtor */
    KDERadio(QWidget* parent=0, const char *name=0, WFlags f=0);
    /** destructor */
    ~KDERadio();
  
  	int power_yes;
  	float freq;
  	QString station_name;

   QFrame *frame;
    
    QComboBox* Lista;
    QPopupMenu *style;
    QPopupMenu *style_dock;
    QPopupMenu *skins;

    QFrame* line1;
    QFrame* line1_2;
    QFrame* line2;
    QFrame* line3;
    
    QLabel* Nicer;
	
	QLabel* One;
	QLabel* Two;
	QLabel* Three;
	QLabel* Four;
	QLabel* Five;
	
	QLabel* Power;
	QLabel* Stereo;
	QLabel* Signal;
	
    
	 QToolButton* Saver_button;
    QToolButton* Mixer_button;
    QToolButton* Rec_button;
    QToolButton* Options_button;
    QToolButton* Seek_button;
    QToolButton* Forward_long;
    QToolButton* Reward_long;
    QToolButton* Reward_short;
    QToolButton* Forward_short;
    QToolButton* Sound_mute;
    QToolButton* Switch_button;
    QToolButton* Previous_button;
    QToolButton* Next_button;
    QToolButton* Move_button;
    QToolButton* Min_button;
    QToolButton* Close_button;

    QLabel *Freq_button;
    QLabel *Vol_button;

    QLabel *Vol_button_1;
    QLabel *Vol_button_2;
    QLabel *Vol_button_3;
    QLabel *Vol_button_4;
    QLabel *Vol_button_5;
    QLabel *Vol_button_6;
    QLabel *Vol_button_7;
    QLabel *Vol_button_8;

    QLabel* Vol_bar_1;
    QLabel* Vol_bar_2;
    QLabel* Vol_bar_3;
    QLabel* Vol_bar_4;
    QLabel* Vol_bar_5;
    QLabel* Vol_bar_6;
    QLabel* Vol_bar_7;
    QLabel* Vol_bar_8;

    
    
    QButtonGroup *buttonGr;
    
    public slots:
    void list_load();
    void nice_text();
    void Switcher();
	void load_sound();
    void load_skin();
	void load_settings();
	void Power_S();

    private slots:

    void Setting_new_freq();
    void mute_pressed();
    void Save();
    void Combo_on();
    void Volume_set();
    void on_Forward();
    void on_reward();
    void on_record();
    void short_reward();
    void short_Forward();
    void setting_leds_signal(); 
    void setting_leds_freq();
    void Setting_new_freq_dok();
    void on_mixer();
    void on_about();
	void on_exit();
    void on_info();
    void on_seeking();
    void device_name_show();
    void next_station();
    void prev_station();
    void set_scale()  ;
    void Volume_up();
	void Volume_down();
    void Setting_new_vol();
    void new_vol_box1();
    void new_vol_box2();
    void new_vol_box3();
    void new_vol_box4();
    void new_vol_box5();
    void new_vol_box6();
    void new_vol_box7();
    void new_vol_box8();
    void close_main();
    void min_main();
    void move_main();
    void aboutQt();
    void Show_skin();
    void Save_data();
    void Create_menu();
    void New_text();
   
    void execute_lirc_command (char *cmd);
    int initialize_lirc();
    void deinitialize_lirc();
    void dataReceived();
    void start_lirc();
   

    
   protected:
    void closeEvent( QCloseEvent* );
    void mouseMoveEvent( QMouseEvent*);
    void mousePressEvent(QMouseEvent * e);
    void makeStyle(const QString &);
};

extern KDERadio *Radio;
extern float freq;
extern QString station_name;


#endif

